DECLARE SUB ToggleMenuFocus (IsOn AS INTEGER, CurPath AS STRING, Config AS ANY)
DECLARE FUNCTION DrawDirectoryList% (StartIndex AS INTEGER, SelectedIdx AS INTEGER, SubDirList() AS ANY, Config AS ANY)

DECLARE SUB ClearKbBuffer ()
DECLARE FUNCTION FileExists% (FilePath AS STRING)
DECLARE FUNCTION GetDosVersion$ ()
DECLARE FUNCTION IsMenuItemEnabled% (MenuItemId AS INTEGER, AreaSelected AS INTEGER, IsDosBoxMode AS INTEGER)
DECLARE SUB DrawPopUp (x AS INTEGER, y AS INTEGER, Title AS STRING, Body() AS STRING, Config AS ANY)

DECLARE SUB HandleDosBoxWarning ()
DECLARE FUNCTION DrawDirectoryList% (StartIndex AS INTEGER, SelectedIdx AS INTEGER, SubDirList() AS ANY, Config AS ANY)
DECLARE SUB ClearKbBuffer ()
DECLARE FUNCTION FileExists% (FilePath AS STRING)
DECLARE FUNCTION GetDosVersion$ ()
DECLARE SUB DrawPopUp (x AS INTEGER, y AS INTEGER, Title AS STRING, Body() AS STRING, Config AS ANY)
DECLARE FUNCTION HandleFileMenu% (CurrentArea AS INTEGER)
DECLARE SUB CreateNew (x AS INTEGER, y AS INTEGER, ItemType AS INTEGER)
DECLARE SUB SetRunOptions (x AS INTEGER, y AS INTEGER)
DECLARE SUB SetColorScheme (x AS INTEGER, y AS INTEGER)
DECLARE SUB SetResolution (x AS INTEGER, y AS INTEGER)
DECLARE SUB SetSortOrder (x AS INTEGER, y AS INTEGER)
DECLARE SUB ToggleDosBoxMode (x AS INTEGER, y AS INTEGER)
DECLARE SUB HandleDirInfo (Dir AS ANY)
DECLARE SUB HandleFileInfo (Item AS ANY)
DECLARE SUB SetEditorPath (x AS INTEGER, y AS INTEGER)
DECLARE SUB ToggleHiddenFiles ()
DECLARE SUB DeleteFile (File AS ANY)
DECLARE SUB DeleteDirectory (Dir AS ANY)
DECLARE SUB HandleOptionsMenu ()
DECLARE SUB HandleHelpMenu ()
DECLARE SUB RunFile (SelectedIdx AS INTEGER)
DECLARE SUB RunFileWithParam (SelectedIdx AS INTEGER)
DECLARE SUB LoadExtActions ()
DECLARE SUB LoadConfig ()
DECLARE SUB SaveConfig (ConfigToSave AS ANY)
DECLARE SUB SetDefaultConfig ()
DECLARE SUB SetFileItems (Dir AS ANY)
DECLARE SUB ChangeDirectory (FullPath AS STRING)
DECLARE SUB SetSubDirs (BaseDir AS ANY)
DECLARE SUB DrawDirScrollBar (SelectedIdx AS INTEGER, TotalDirs AS INTEGER, NumRows AS INTEGER)
DECLARE SUB DrawFileList (SelectedIdx AS INTEGER, FileItemList() AS ANY, Config AS ANY)
DECLARE SUB DrawFileScrollBar (SelectedIdx AS INTEGER, TotalFiles AS INTEGER, NumRows AS INTEGER)
DECLARE SUB DrawScr (CurPath AS STRING, Config AS ANY)
DECLARE SUB DrawMenu (x AS INTEGER, Options() AS ANY, SelectedArea AS INTEGER, Config AS ANY)
DECLARE SUB DrawPopUp (x AS INTEGER, y AS INTEGER, Title AS STRING, Body() AS STRING, Config AS ANY)
DECLARE SUB ClearKbBuffer ()

CONST VER = "0.40-RC1"
CONST BUILDDATE = "06-22-2020"

CONST TRUE = -1
CONST FALSE = 0
CONST UNSET = 999

CONST DEBUG = FALSE

CONST NONE = -1
CONST AREADIR = 500
CONST AREAFILE = 600

CONST MAXSUBDIRS = 240
CONST MAXFILES = 195

CONST DOSBOXVERSUBSTR = "DOSBOX"

CONST ITEMTYPEFILE = AREAFILE
CONST ITEMTYPEDIR = AREADIR

CONST TEMPDIRFILENAME = "DIRTEMP.TMP"
CONST TEMPFILEFILENAME = "FILETEMP.TMP"
CONST TEMPVERFILENAME = "VER.TMP"
CONST CONFIGFILENAME = "CONFIG.DAT"
CONST EXTACTIONFILENAME = "EXTACTN.DAT"

'todo: configurable based on resolution set by user config
CONST MAXDIRDISPLAYED = 18
CONST MAXFILEDISPLAYED = 18

CONST FILESORT = "/O"
CONST FILESORTNAMES = "N"
CONST FILESORTSIZE = "S"
CONST FILESORTEXTENSION = "E"
CONST FILESORTDATE = "D"
CONST FILESORTREVERSE = "-"

CONST SHOWHIDDENFILESTEXT = "Show Hidden Files"
CONST HIDEHIDDENFILESTEXT = "Hide Hidden Files"

'not sure how i feel about these... this seems very COBOL-ish.
CONST MENUIDFILENEW = 100
CONST MENUIDFILEOPEN = 110
CONST MENUIDFILECOPY = 120
CONST MENUIDFILEMOVE = 130
CONST MENUIDFILERENAME = 140
CONST MENUIDFILEDELETE = 150
CONST MENUIDFILEEXIT = 160

CONST MENUIDOPTIONHIDDENFILES = 200
CONST MENUIDOPTOINSORTORDER = 210
CONST MENUIDOPTIONEXTACTION = 220
CONST MENUIDOPTIONEDITPATH = 230
CONST MENUIDOPTIONDOSBOX = 240
CONST MENUIDOPTIONRESOLUTION = 250
CONST MENUIDOPTIONCOLORSCHEME = 260

CONST MENUIDHELPHELP = 300
CONST MENUIDHELPABOUT = 310

CONST MENUIDDIVIDER = 400

TYPE Directory
    Id AS INTEGER
    ParentId AS INTEGER       'this currently isn't used...
    DirName AS STRING * 8
    FullPath AS STRING * 96
END TYPE

TYPE FileItem
    DisplayString AS STRING * 59
    filename AS STRING * 8
    FileExtension AS STRING * 3
    ParentDirName AS STRING * 8
    FullPath AS STRING * 96
END TYPE

TYPE MenuItem
    Id AS INTEGER
    text AS STRING * 36
    HighlightCharacter AS STRING * 1
    HighlightXOffset AS INTEGER
END TYPE

TYPE Configuration
    DosVersion AS STRING * 64
    NumRows AS INTEGER
    NumColumns AS INTEGER
    EditPath AS STRING * 64
    XtCompMode AS INTEGER
    DosBoxCompMode AS INTEGER
    TitleBarFgColor AS INTEGER
    TitleBarBgColor AS INTEGER
    MenuBarFgColor AS INTEGER
    MenuBarBgColor AS INTEGER
    PopUpBgColor AS INTEGER
    PopUpFgColor AS INTEGER
    MainBgColor AS INTEGER
    MainFgColor AS INTEGER
    MainSelectedColor AS INTEGER
    ShowDosBoxWarning AS INTEGER
    ShowHiddenFiles AS INTEGER
    FileSortOrder AS STRING * 4
    MenuDisabledFgColor AS INTEGER
    ColorSchemeId AS INTEGER
END TYPE

TYPE CustomExtensionAction
    FileExtension AS STRING * 3
    RunAction AS STRING * 64
    IsValid AS INTEGER
END TYPE

