DECLARE FUNCTION CheckDirExists% (BaseDirPath$)
DECLARE FUNCTION CheckPathCmdParam$ ()
DECLARE FUNCTION GetDisplayPath$ (PathToTrim AS STRING)
DECLARE SUB ResetConfigData ()
DECLARE SUB PrintCommandHelp ()
DECLARE SUB CheckXtMode ()
DECLARE FUNCTION GetXtKbScanCode% ()
DECLARE SUB SaveExtActions (ExtActionsToSave() AS ANY, IsNewFile AS INTEGER)
DECLARE SUB DeleteExtAction (Extension AS STRING)
DECLARE SUB AddExtActions (x AS INTEGER, y AS INTEGER)
DECLARE SUB CopyFile (x AS INTEGER, y AS INTEGER, FileToMove AS ANY)
DECLARE SUB MoveFile (x AS INTEGER, y AS INTEGER, FileToMove AS ANY)
DECLARE SUB RenameFile (x AS INTEGER, y AS INTEGER, FileToRename AS ANY)
DECLARE SUB OpenLocation (x AS INTEGER, y AS INTEGER)

'$INCLUDE: 'FILEINC.BI'

DEFINT A-Z

SCREEN 0

CONST HELPCOMMANDPARAM = "/?"
CONST XTCOMMANDPARAM = "/XT"
CONST RESETCOMMANDPARAM = "/RESET"


'Check if command line help needs to be displayed.
CALL PrintCommandHelp

'Check if command line reset is requested.
CALL ResetConfigData

CLS

DIM BaseDir AS Directory

DIM CurrentDirDisplayIdx AS INTEGER

DIM ErrorBody(4) AS STRING

DIM SHARED SelectedArea AS INTEGER
DIM SHARED CurrentPath  AS STRING
DIM SHARED CurrentDrive AS STRING
DIM SHARED SelectedDirIdx AS INTEGER
DIM SHARED SelectedFileIdx AS INTEGER
DIM SHARED Config AS Configuration

'Menu items
DIM FileMenuOptions(9) AS MenuItem
FileMenuOptions(0).Id = MENUIDFILENEW
FileMenuOptions(0).text = "New"
FileMenuOptions(0).HighlightCharacter = "N"
FileMenuOptions(0).HighlightXOffset = 0

FileMenuOptions(1).Id = MENUIDFILEOPEN
FileMenuOptions(1).text = "Open"
FileMenuOptions(1).HighlightCharacter = "O"
FileMenuOptions(1).HighlightXOffset = 0

FileMenuOptions(2).Id = MENUIDDIVIDER
FileMenuOptions(2).text = ""
FileMenuOptions(2).HighlightCharacter = ""
FileMenuOptions(2).HighlightXOffset = 0

FileMenuOptions(3).Id = MENUIDFILEDELETE
FileMenuOptions(3).text = "Delete    DEL"
FileMenuOptions(3).HighlightCharacter = "D"
FileMenuOptions(3).HighlightXOffset = 0

FileMenuOptions(4).Id = MENUIDDIVIDER
FileMenuOptions(4).text = ""
FileMenuOptions(4).HighlightCharacter = ""
FileMenuOptions(4).HighlightXOffset = 0

FileMenuOptions(5).Id = MENUIDFILERENAME
FileMenuOptions(5).text = "Rename    F2"
FileMenuOptions(5).HighlightCharacter = "R"
FileMenuOptions(5).HighlightXOffset = 0

FileMenuOptions(6).Id = MENUIDFILEMOVE
FileMenuOptions(6).text = "Move      F7"
FileMenuOptions(6).HighlightCharacter = "M"
FileMenuOptions(6).HighlightXOffset = 0

FileMenuOptions(7).Id = MENUIDFILECOPY
FileMenuOptions(7).text = "Copy      F8"
FileMenuOptions(7).HighlightCharacter = "C"
FileMenuOptions(7).HighlightXOffset = 0

FileMenuOptions(8).Id = MENUIDDIVIDER
FileMenuOptions(8).text = ""
FileMenuOptions(8).HighlightCharacter = ""
FileMenuOptions(8).HighlightXOffset = 0

FileMenuOptions(9).Id = MENUIDFILEEXIT
FileMenuOptions(9).text = "Exit"
FileMenuOptions(9).HighlightCharacter = "x"
FileMenuOptions(9).HighlightXOffset = 1



DIM HelpMenuOptions(1) AS MenuItem
HelpMenuOptions(0).Id = MENUIDHELPHELP
HelpMenuOptions(0).text = "Help"
HelpMenuOptions(0).HighlightCharacter = "H"
HelpMenuOptions(0).HighlightXOffset = 0

HelpMenuOptions(1).Id = MENUIDHELPABOUT
HelpMenuOptions(1).text = "About"
HelpMenuOptions(1).HighlightCharacter = "A"
HelpMenuOptions(1).HighlightXOffset = 0

DIM OptionMenuOptions(9) AS MenuItem
OptionMenuOptions(0).Id = MENUIDOPTIONHIDDENFILES
OptionMenuOptions(0).text = SHOWHIDDENFILESTEXT
OptionMenuOptions(0).HighlightCharacter = "H"
OptionMenuOptions(0).HighlightXOffset = 5

OptionMenuOptions(1).Id = MENUIDOPTIONSORTORDER
OptionMenuOptions(1).text = "Set Sort Order"
OptionMenuOptions(1).HighlightCharacter = "S"
OptionMenuOptions(1).HighlightXOffset = 4

OptionMenuOptions(2).Id = MENUIDDIVIDER
OptionMenuOptions(2).text = ""
OptionMenuOptions(2).HighlightCharacter = ""
OptionMenuOptions(2).HighlightXOffset = 0


OptionMenuOptions(3).Id = MENUIDOPTIONEXTACTION
OptionMenuOptions(3).text = "Manage File Run Options"
OptionMenuOptions(3).HighlightCharacter = "R"
OptionMenuOptions(3).HighlightXOffset = 12

OptionMenuOptions(4).Id = MENUIDOPTIONEDITPATH
OptionMenuOptions(4).text = "Set Text Editor Path"
OptionMenuOptions(4).HighlightCharacter = "T"
OptionMenuOptions(4).HighlightXOffset = 4


OptionMenuOptions(5).Id = MENUIDDIVIDER
OptionMenuOptions(5).text = ""
OptionMenuOptions(5).HighlightCharacter = ""
OptionMenuOptions(5).HighlightXOffset = 0


OptionMenuOptions(6).Id = MENUIDOPTIONDOSBOX
OptionMenuOptions(6).text = "Toggle DOSBox Compatibility Mode"
OptionMenuOptions(6).HighlightCharacter = "M"
OptionMenuOptions(6).HighlightXOffset = 28

OptionMenuOptions(7).Id = MENUIDDIVIDER
OptionMenuOptions(7).text = ""
OptionMenuOptions(7).HighlightCharacter = ""
OptionMenuOptions(7).HighlightXOffset = 0


OptionMenuOptions(8).Id = MENUIDOPTIONRESOLUTION
OptionMenuOptions(8).text = "Display Resolution"
OptionMenuOptions(8).HighlightCharacter = "D"
OptionMenuOptions(8).HighlightXOffset = 0

OptionMenuOptions(9).Id = MENUIDOPTIONCOLORSCHEME
OptionMenuOptions(9).text = "Color Scheme"
OptionMenuOptions(9).HighlightCharacter = "C"
OptionMenuOptions(9).HighlightXOffset = 0


REM $DYNAMIC
REDIM SHARED SubDirs(MAXSUBDIRS) AS Directory
REDIM SHARED FileItems(MAXFILES) AS FileItem
REDIM SHARED ExtensionActions(0) AS CustomExtensionAction


ErrorBody(0) = ""
ErrorBody(1) = ""
ErrorBody(2) = ""
ErrorBody(3) = ""
ErrorBody(4) = "Press any key to continue"

'get base path from command line if exists. (defaults to C:\)
BasePath$ = CheckPathCmdParam

BaseDir.Id = 0
BaseDir.ParentId = 0
BaseDir.DirName = "" 'not needed on initial dir
BaseDir.FullPath = BasePath$

CurrentPath = RTRIM$(BaseDir.FullPath)
CurrentDrive = LEFT$(BaseDir.FullPath, 1)
CurrentDirDisplayIdx = 0
SelectedDirIdx = 0
SelectedFileIdx = NONE
SelectedArea = AREADIR


CALL LoadConfig
CALL LoadExtActions

CALL CheckXtMode

CALL SetSubDirs(BaseDir)
CALL SetFileItems(BaseDir)


'draw fresh screen.
CLS
WIDTH Config.NumColumns, Config.NumRows


'if using DOSBox, warn them DIR listing's sort is limited.
IF Config.ShowDosBoxWarning THEN
    CALL DrawScr(CurrentPath, Config)
    CALL HandleDosBoxWarning
END IF


CALL DrawScr(CurrentPath, Config)
CurrentDirDisplayIdx = DrawDirectoryList(CurrentDirDisplayIdx, SelectedDirIdx, SubDirs(), Config)
CALL DrawDirScrollBar(0, UBOUND(SubDirs), Config.NumRows)
CALL DrawFileList(NONE, FileItems(), Config)

ScanCode = 0
PrevScanCode = NONE

'WHILE ScanCode <> 1
'    COLOR 7, 0
'    ScanCode = INP(96)
'    PRINT "Scancode: "; ScanCode
'WEND
'END


IsRunning% = TRUE
IsAltToggled = FALSE
IsAltUntoggledFromMenu = FALSE
IsDirScrollBarDrawRequired% = FALSE
IsFileListDrawRequired% = FALSE
IsRedrawRequired% = FALSE

'user input
WHILE IsRunning%

    IF Config.XtCompMode THEN
        ScanCode = GetXtKbScanCode%
    ELSE
        ScanCode = INP(96)
    END IF


    IF DEBUG THEN
        LOCATE 7, 50
        COLOR 7, 0
        PRINT "CurDirDisIdx: "; CurrentDirDisplayIdx
        LOCATE 8, 50
        PRINT "SelectedDirIdx: "; SelectedDirIdx
        LOCATE 9, 50
        PRINT "Max Dir Display Id: "; MAXDIRDISPLAYED
    END IF

    IF ScanCode <> PrevScanCode THEN

        IF NOT Config.XtCompMode THEN
            'Having the buffer cleared here seems to help the "key bounce"
            'issue on the menus.
            CALL ClearKbBuffer
        END IF

        PrevScanCode = ScanCode

        SELECT CASE (ScanCode)

            'ALT Pressed
            CASE 56
                IF IsAltToggled THEN
                    CALL ToggleMenuFocus(FALSE, CurrentPath, Config)
                    IsAltToggled = FALSE
                ELSE
                    CALL ToggleMenuFocus(TRUE, CurrentPath, Config)
                    IsAltToggled = TRUE
                END IF


            'ESC
            CASE 1
                IF IsAltToggled THEN
                    CALL ToggleMenuFocus(FALSE, CurrentPath, Config)
                    IsAltToggled = FALSE
                ELSE
                    IF DEBUG THEN
                        IsRunning% = FALSE
                    END IF
                END IF

    
            'TAB - swap between areas.
            CASE 15
                IF SelectedArea = AREADIR THEN
                    SelectedArea = AREAFILE
                    UNUSED = DrawDirectoryList(SelectedDirIdx - 9, NONE, SubDirs(), Config)

                    'set to first file selected.
                    SelectedFileIdx = 0
                    CALL DrawFileList(SelectedFileIdx, FileItems(), Config)

                ELSE
                    SelectedArea = AREADIR
                    UNUSED = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)

                    'reset selected file index
                    SelectedFileIdx = NONE
                    CALL DrawFileList(SelectedFileIdx, FileItems(), Config)

                END IF

           
           
            'O
            CASE 24
                IF IsAltToggled THEN
                    CALL ToggleMenuFocus(FALSE, CurrentPath, Config)
                    CALL DrawMenu(13, OptionMenuOptions(), SelectedArea, Config)
                    CALL HandleOptionsMenu

                    IsAltToggled = FALSE
                    IsAltUntoggledFromMenu = TRUE

                END IF


            'P or page up
            CASE 25, 73
               
                IF SelectedArea = AREADIR THEN
                    SelectedDirIdx = SelectedDirIdx - MAXDIRDISPLAYED
                    IF SelectedDirIdx < 0 THEN
                        SelectedDirIdx = 0
                    END IF
               
                    CurrentDirDisplayIdx = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)
                   
                    IsDirScrollBarDrawRequired% = TRUE

                ELSEIF SelectedArea = AREAFILE AND SelectedFileIdx > 0 THEN
                    SelectedFileIdx = SelectedFileIdx - MAXFILEDISPLAYED
                    IF SelectedFileIdx < 0 THEN
                        SelectedFileIdx = 0
                    END IF
                    IsFileListDrawRequired% = TRUE

                END IF
                


            'enter
            CASE 28

                IF SelectedArea = AREADIR THEN
                    'interesting bug/workarond here. If FullPath isn't copied
                    'to a local string,eventually string corruption
                    'occurs and crashes everything because SetSubDirs
                    'gets called from ChangeDirectory which reallocates
                    'the SubDirs array while FullPath is still being
                    'accessed from one of it's elements.

                    NextDir$ = SubDirs(SelectedDirIdx).FullPath

                    CALL ChangeDirectory(NextDir$)
                   
                    'Reset selected index after changing dirs.
                    SelectedDirIdx = 0

                    CurrentDirDisplayIdx = DrawDirectoryList(0, SelectedDirIdx, SubDirs(), Config)

                    IsDirScrollBarDrawRequired% = TRUE

                ELSEIF SelectedArea = AREAFILE AND SelectedFileIdx < UBOUND(FileItems) THEN

                    'run file selected.

                    CALL RunFile(SelectedFileIdx)

                    'redraw screen at prev location.
                    CALL DrawScr(CurrentPath, Config)
                    UNUSED = DrawDirectoryList(NONE, NONE, SubDirs(), Config)
                    CALL DrawDirScrollBar(NONE, UBOUND(SubDirs), Config.NumRows)
                    CALL DrawFileList(SelectedFileIdx, FileItems(), Config)

                END IF
                


            'F
            CASE 33
                IF IsAltToggled THEN
                    CALL ToggleMenuFocus(FALSE, CurrentPath, Config)
                    CALL DrawMenu(3, FileMenuOptions(), SelectedArea, Config)
                    IsRunning% = HandleFileMenu(SelectedArea)

                    IsAltToggled = FALSE
                    IsAltUntoggledFromMenu = TRUE
                                      
                END IF

      
            'H
            CASE 35
                IF IsAltToggled THEN
                    CALL ToggleMenuFocus(FALSE, CurrentPath, Config)
                    CALL DrawMenu(69, HelpMenuOptions(), SelectedArea, Config)
                    CALL HandleHelpMenu

                    IsAltToggled = FALSE
                    IsAltUntoggledFromMenu = TRUE

                END IF



            'C
            CASE 46
                IF IsAltToggled THEN
                    CALL ChangeDirectory("")
                                      
                    'reset selected items.
                    SelectedDirIdx = 0
                    SelectedFileIdx = 0

                    IsAltToggled = FALSE
                    IsAltUntoggledFromMenu = TRUE
                END IF

              
            'm or Page down
            CASE 50, 81

                IF SelectedArea = AREADIR AND CurrentDirDisplayIdx >= MAXDIRDISPLAYED THEN
                    'set selected to next page and check if it's in bounds.
                    SelectedDirIdx = SelectedDirIdx + MAXDIRDISPLAYED
                       
                    IF SelectedDirIdx > UBOUND(SubDirs) THEN
                        SelectedDirIdx = UBOUND(SubDirs)
                    END IF

                    '-9 seems to be the magic number for mid-centered selection.
                    'todo: const that.
                    CurrentDirDisplayIdx = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)
               
                    IsDirScrollBarDrawRequired% = TRUE
                
                ELSEIF SelectedArea = AREAFILE THEN
                    SelectedFileIdx = SelectedFileIdx + MAXFILEDISPLAYED
                    IF SelectedFileIdx > UBOUND(FileItems) - 1 THEN
                        SelectedFileIdx = UBOUND(FileItems) - 1
                    END IF
                    IsFileListDrawRequired% = TRUE

                END IF

       
            'F1
            CASE 59
                IF SelectedArea = AREADIR THEN
                    IF SelectedDirIdx >= 0 AND SelectedDirIdx <= UBOUND(SubDirs) THEN
                        CALL HandleDirInfo(SubDirs(SelectedDirIdx))
                        IsRedrawRequired% = TRUE
                    END IF

                ELSEIF SelectedArea = AREAFILE THEN
                    IF SelectedFileIdx < UBOUND(FileItems) AND SelectedFileIdx >= 0 THEN
                        CALL HandleFileInfo(FileItems(SelectedFileIdx))
                  
                        IsRedrawRequired% = TRUE

                    END IF

                END IF

            'F2
            CASE 60
                IF SelectedArea = AREAFILE THEN
                    IF SelectedFileIdx < UBOUND(FileItems) AND SelectedFileIdx >= 0 THEN
                        CALL RenameFile(16, 6, FileItems(SelectedFileIdx))
                       
                        UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)
                        CALL ChangeDirectory(CurrentPath)
                       
                        IsRedrawRequired% = TRUE
                    END IF
                END IF

            'F5
            CASE 63
                IF SelectedArea = AREAFILE AND SelectedFileIdx < UBOUND(FileItems) THEN
                   
                    'run file selected with custom parameters.

                    CALL RunFileWithParam(SelectedFileIdx)

                    IsRedrawRequired% = TRUE

                END IF

            'F7
            CASE 65
                IF SelectedArea = AREAFILE THEN
                    IF SelectedFileIdx < UBOUND(FileItems) AND SelectedFileIdx >= 0 THEN
                        CALL MoveFile(2, 5, FileItems(SelectedFileIdx))
                      
                        UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)
                        CALL ChangeDirectory(CurrentPath)
                      
                        IsRedrawRequired% = TRUE
                    END IF
                END IF



            'F8
            CASE 66
                IF SelectedArea = AREAFILE THEN
                    IF SelectedFileIdx < UBOUND(FileItems) AND SelectedFileIdx >= 0 THEN
                        CALL CopyFile(2, 5, FileItems(SelectedFileIdx))
                      
                        UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)
                        CALL ChangeDirectory(CurrentPath)
                      
                        IsRedrawRequired% = TRUE
                    END IF
                END IF

            'F10 - shortcut to change dir
            CASE 68
                CALL ChangeDirectory("")
                                     
                'reset selected items.
                SelectedDirIdx = 0
                SelectedFileIdx = 0

                IsAltToggled = FALSE
                IsAltUntoggledFromMenu = TRUE



            'up arrow
            CASE 72
                IF SelectedArea = AREADIR AND SelectedDirIdx > 0 THEN

                    SelectedDirIdx = SelectedDirIdx - 1

                    TempSelected% = (CurrentDirDisplayIdx + 15) - SelectedDirIdx

                    IF TempSelected% >= 5 THEN
                        CurrentDirDisplayIdx = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)
                    END IF

                    IsDirScrollBarDrawRequired% = TRUE

                    'change file for each dir views... not sure i want this
                    'CALL SetFileItems(SubDirs(SelectedDirIdx))
                    'CALL DrawFileList(NONE) 'none selected
                    'CALL DrawFileScrollBar(NONE)

                  
                ELSEIF SelectedArea = AREAFILE AND SelectedFileIdx > 0 THEN
                    SelectedFileIdx = SelectedFileIdx - 1
                    IsFileListDrawRequired% = TRUE

                END IF

                

            'down arrow
            CASE 80
                IF SelectedArea = AREADIR AND SelectedDirIdx < UBOUND(SubDirs) THEN
                   
                    SelectedDirIdx = SelectedDirIdx + 1

                    IF SelectedDirIdx <= CurrentDirDisplayIdx - 10 THEN
                        CurrentDirDisplayIdx = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)

                    ELSE
                        CurrentDirDisplayIdx = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)

                    END IF

                    IsDirScrollBarDrawRequired% = TRUE

                    'change file for each dir views... not sure i want this
                    'CALL SetFileItems(SubDirs(SelectedDirIdx))
                    'CALL DrawFileList(NONE) 'none selected
                    'CALL DrawFileScrollBar(NONE)


                ELSEIF SelectedArea = AREAFILE AND SelectedFileIdx < UBOUND(FileItems) - 1 THEN
                    SelectedFileIdx = SelectedFileIdx + 1
                    IsFileListDrawRequired% = TRUE

                END IF

            'DELETE
            CASE 83

                IF SelectedArea = AREADIR THEN
                    
                    CALL DeleteDirectory(SubDirs(SelectedDirIdx))
                    CALL ChangeDirectory(CurrentPath)

                    SelectedDirIdx = 0
                    CurrentDirDisplayIdx = DrawDirectoryList(0, SelectedDirIdx, SubDirs(), Config)
                    

                ELSEIF SelectedArea = AREAFILE THEN
                    
                    CALL DeleteFile(FileItems(SelectedFileIdx))
                    CALL ChangeDirectory(CurrentPath)

                    'make sure idx is still valid if deleted last
                    'entry in the file list.
                    IF SelectedFileIdx >= UBOUND(FileItems) THEN
                        SelectedFileIdx = UBOUND(FileItems) - 1
                    END IF

                    'TODO : fix directory draw so it's correct.
                    UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)
                

                END IF


                IsDirScrollBarDrawRequired% = TRUE
                IsFileListDrawRequired% = TRUE


        END SELECT

    END IF


    'close menu and redraw areas as necessary.
    IF IsAltUntoggledFromMenu THEN
        CALL DrawScr(CurrentPath, Config)
        IF SelectedArea = AREADIR THEN
                   
            UNUSED = DrawDirectoryList(SelectedDirIdx - 9, SelectedDirIdx, SubDirs(), Config)

            'reset selected file index
            SelectedFileIdx = NONE
            CALL DrawFileList(SelectedFileIdx, FileItems(), Config)
        ELSE
            UNUSED = DrawDirectoryList(NONE, NONE, SubDirs(), Config)
            CALL DrawDirScrollBar(NONE, UBOUND(SubDirs), Config.NumRows)
            CALL DrawFileList(SelectedFileIdx, FileItems(), Config)
        END IF

        IsDirScrollBarDrawRequired% = TRUE

        IsAltUntoggledFromMenu = FALSE

        'set prev code to ENTER so not to trigger a
        'false positive enter input.
        PrevScanCode = 28

    END IF

    'redraw just file list
    IF IsFileListDrawRequired% THEN
        CALL DrawFileList(SelectedFileIdx, FileItems(), Config)
        CALL DrawFileScrollBar(SelectedFileIdx, UBOUND(FileItems), Config.NumRows)
        IsFileListDrawRequired% = FALSE
    END IF

    'redraw dir scroll bar
    IF IsDirScrollBarDrawRequired% THEN
        CALL DrawDirScrollBar(SelectedDirIdx, UBOUND(SubDirs), Config.NumRows)
        IsDirScrollBarDrawRequired% = FALSE
    END IF

    'redraw screen at prev location.
    IF IsRedrawRequired% THEN
        CALL DrawScr(CurrentPath, Config)
        UNUSED = DrawDirectoryList(NONE, NONE, SubDirs(), Config)
        CALL DrawDirScrollBar(NONE, UBOUND(SubDirs), Config.NumRows)
        CALL DrawFileList(SelectedFileIdx, FileItems(), Config)

        'Set prev to enter so not to trigger enter call
        PrevScanCode = 28

        IsRedrawRequired% = FALSE
    END IF


    'CALL ClearKbBuffer

WEND
                  

'one last KB buffer reset before leaving.
'CALL ClearKbBuffer

CLS
COLOR 7, 0
PRINT "Goodbye."

END




'Global error handler for raised errors.
ErrorHandler:


    ErrorBody(0) = "An error occurred. Please try again."

    SELECT CASE ERR
        CASE 52
            ErrorBody(1) = "Error Code: 52 - Bad file name or number"

        CASE 53
            ErrorBody(1) = "Error Code: 53 - File not found"

        CASE 54
            ErrorBody(1) = "Error Code: 54 - Bad file mode"

        CASE 55
            ErrorBody(1) = "Error Code: 55 - File already open"

        CASE 57
            ErrorBody(1) = "Error Code: 57 - Device IO Error"

        CASE 58
            ErrorBody(1) = "Error Code: 58 - File already exists"

        CASE 59
            ErrorBody(1) = "Error Code: 59 - Bad record length"

        CASE 61
            ErrorBody(1) = "Error Code: 61 - Disk Full"

        CASE 62
            ErrorBody(1) = "Error Code: 62 - Input past end of file"

        CASE 63
            ErrorBody(1) = "Error Code: 63 - Bad Record Number"

        CASE 64
            ErrorBody(1) = "Error Code: 64 - Bad file name"

        CASE 67
            ErrorBody(1) = "Error Code: 67 - Too many files open"

        CASE 68
            ErrorBody(1) = "Error Code: 68 - Device unavailable"

        CASE 70
            ErrorBody(1) = "Error Code: 70 - Permission Denied"

        CASE 71
            ErrorBody(1) = "Error Code: 71 - Disk not ready"

        CASE 72
            ErrorBody(1) = "Error Code: 72 - Disk media error"

        CASE 74
            ErrorBody(1) = "Error Code: 74 - Rename across disks not allowed"

        CASE 75
            ErrorBody(1) = "Error Code: 75 - Path/file access error"

        CASE 76
            ErrorBody(1) = "Error Code: 76 - Path not found"

    END SELECT

    CALL DrawPopUp(10, 10, "Error", ErrorBody(), Config)
    SLEEP
    RUN 'restarts the application.

REM $STATIC
SUB AddExtActions (x AS INTEGER, y AS INTEGER)

'Prompts user to enter extension run action to create.
'Saves config if the user chooses to do so.

yLine1% = 6
yLine2% = 7

DIM Body(9) AS STRING
Body(0) = SPACE$(65)
Body(1) = "The associated filename will be added after the "
Body(2) = "run action command line provided automatically at"
Body(3) = "time of launch."
Body(4) = ""
Body(5) = "File Extension: "
Body(6) = "    Run Action: "
Body(7) = ""
Body(8) = "[Enter] To Add New Run Action"
Body(9) = "  [Esc] To Cancel"

CALL DrawPopUp(x, y, "Add Run Action", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + yLine1%, x + 17
PRINT SPACE$(3)

LOCATE y + yLine2%, x + 17
PRINT SPACE$(50)

i$ = ""

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)


    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z,:, \, / and . characters in new name.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z")) OR (i$ = ".") OR (i$ = "\") OR (i$ = ":") OR (i$ = "/") OR (i$ = " ") THEN
            IF LEN(PathBuffer$) < 53 THEN
                'don't allow special chars in file extension
                IF (LEN(PathBuffer$) < 3 AND i$ <> ":" AND i$ <> "\" AND i$ <> "." AND i$ <> "/") OR (LEN(PathBuffer$) >= 3) THEN
                    PathBuffer$ = PathBuffer$ + i$
                END IF
            END IF

        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            IF LEN(PathBuffer$) > 3 THEN
                LOCATE y + yLine2%, x + 17 + LEN(PathBuffer$) - 4
            ELSE
                LOCATE y + yLine1%, x + 17 + LEN(PathBuffer$) - 1
            END IF

            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
       
        'draw first 3 chars on extension line, past that on second line.
        IF LEN(PathBuffer$) > 3 THEN
            LOCATE y + yLine1%, x + 17
            PRINT LEFT$(PathBuffer$, 3)

            LOCATE y + yLine2%, x + 17
            PRINT RIGHT$(PathBuffer$, LEN(PathBuffer$) - 3)
        ELSE
            LOCATE y + yLine1%, x + 17
            PRINT PathBuffer$
        END IF


    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% THEN

    IsError% = FALSE

    IF LEN(PathBuffer$) > 3 THEN

        FileExt$ = LEFT$(PathBuffer$, 3)
        FileAct$ = RIGHT$(PathBuffer$, LEN(PathBuffer$) - 3)

        FileExt$ = LTRIM$(RTRIM$(FileExt$))
        FileAct$ = LTRIM$(RTRIM$(FileAct$))

        'make sure there's a value for both fields before saving.
        IF FileExt$ <> "" AND FileAct$ <> "" THEN

            ExistingActionFound% = FALSE

            NewSize% = UBOUND(ExtensionActions) + 1

            DIM TempExtActionsToSave(NewSize%) AS CustomExtensionAction
    
            'copy in existing entries
            FOR i% = 0 TO UBOUND(ExtensionActions)

                IF ExtensionActions(i%).FileExtension = FileExt$ THEN
                    ExistingActionFound% = TRUE
                END IF

                TempExtActionsToSave(i%).FileExtension = ExtensionActions(i%).FileExtension
                TempExtActionsToSave(i%).RunAction = ExtensionActions(i%).RunAction
            NEXT i%

            'Add new value at the end
            TempExtActionsToSave(NewSize%).FileExtension = FileExt$
            TempExtActionsToSave(NewSize%).RunAction = FileAct$

            IF NOT ExistingActionFound% THEN
                CALL SaveExtActions(TempExtActionsToSave(), FALSE)
                CALL LoadExtActions
            ELSE
                DIM ExtExistsErrorBody(3) AS STRING
                ExtExistsErrorBody(0) = "A run action alread exists for the"
                ExtExistsErrorBody(1) = "file extension entered. Please delete"
                ExtExistsErrorBody(2) = "the existing record before adding a new one"
                ExtExistsErrorBody(3) = "     Press Any Key to Continue"
                CALL DrawPopUp(16, 7, "Extension Exists Error", ExtExistsErrorBody(), Config)
                SLEEP
            END IF


        ELSE
            IsError% = TRUE
        END IF

    ELSE
        IsError% = TRUE
    END IF

    IF IsError% THEN
        DIM ErrorBody(2) AS STRING
        ErrorBody(0) = "Run action must contain both"
        ErrorBody(1) = "a file extension and run action."
        ErrorBody(2) = "Press Any Key to Continue"
        CALL DrawPopUp(20, 12, "Error", ErrorBody(), Config)
        SLEEP

    END IF

END IF


END SUB

DEFSNG A-Z
SUB ChangeDirectory (FullPath AS STRING)


'Ask user for path if none specified
IF RTRIM$(FullPath) = "" THEN

    COLOR Config.MenuBarBgColor, Config.MenuBarBgColor
    LOCATE 3, 18
    PRINT SPACE$(Config.NumColumns - 17)
   
    COLOR Config.MenuBarFgColor, Config.MenuBarBgColor
    LOCATE 3, 18

    INPUT "", NewBaseDirPath$

    'check for invalid input, if found, display message and don't change
    'the directory.
    IF INSTR(NewBaseDirPath$, ".") > 0 THEN
        DIM InpErrBody(5) AS STRING
        InpErrBody(0) = "Path input cannot contain relative path"
        InpErrBody(1) = "identifiers such as `.' or `..'. Please use"
        InpErrBody(2) = "either a relative path or absolute path"
        InpErrBody(3) = "that does not contain these characters."
        InpErrBody(4) = ""
        InpErrBody(5) = "  Plese press any key to continue."

        CALL DrawPopUp(10, 7, "Invalid Characters in Path", InpErrBody(), Config)
       
        DO: LOOP WHILE INKEY$ = ""
        EXIT SUB

    END IF



    'drive only paths missing final slash.
    IF LEN(NewBaseDirPath$) = 2 AND INSTR(NewBaseDirPath$, ":") > 0 THEN
        NewBaseDirPath$ = NewBaseDirPath$ + "\"

    'santize input for relative paths or absolute paths
    ELSEIF INSTR(NewBaseDirPath$, ":\") = 0 AND (INSTR(NewBaseDirPath$, "\") = 0 OR LEFT$(NewBaseDirPath$, 1) <> "\") THEN
       
        IF RIGHT$(CurrentPath$, 1) <> "\" THEN
            NewBaseDirPath$ = CurrentPath + "\" + NewBaseDirPath$
        ELSE
            NewBaseDirPath$ = CurrentPath + NewBaseDirPath$
        END IF

    END IF

    'if not drive only path and has a trailing slash, remove it.
    IF LEN(NewBaseDirPath$) > 3 AND RIGHT$(NewBaseDirPath$, 1) = "\" THEN
        NewBaseDirPath$ = LEFT$(NewBaseDirPath$, LEN(NewBaseDirPath$) - 1)
    END IF

    'check if dir entered actually exists.
    IF NOT CheckDirExists%(NewBaseDirPath$) THEN
        DIM DirNotFoundErr(5) AS STRING
        DirNotFoundErr(0) = "The directory entered cannot be found. Please"
        DirNotFoundErr(1) = "check the path and try again."
        DirNotFoundErr(2) = ""
        DirNotFoundErr(3) = "Path: " + UCASE$(NewBaseDirPath$)
        DirNotFoundErr(4) = ""
        DirNotFoundErr(5) = "  Please press any key to continue."

        CALL DrawPopUp(7, 6, "Directory Not Found", DirNotFoundErr(), Config)

        DO: LOOP WHILE INKEY$ = ""
        EXIT SUB
   
    END IF


'if using back path, calculate based on full path.
ELSEIF INSTR(RTRIM$(FullPath), "\..") > 0 THEN


    Dir$ = RTRIM$(FullPath)

    'remove "\.." from string.
    Dir$ = LEFT$(Dir$, INSTR(Dir$, "\..") - 1)

    FinalPath$ = ""

    Drive$ = LEFT$(Dir$, 3)             'get drive
    Dir$ = RIGHT$(Dir$, LEN(Dir$) - 3)  'get everything past the drive

    DoneSearching% = FALSE

    WHILE NOT DoneSearching%

        'if no more slashes in dir, we're done searching.
        IF INSTR(Dir$, "\") = 0 THEN
            DoneSearching% = TRUE

        
        ELSE
            'append dir segment up to slash to final path.
            'start dir does not end with a "\" so will not be appended.

            FinalPath$ = FinalPath$ + "\" + LEFT$(Dir$, INSTR(Dir$, "\") - 1)

            'set dir to what's left of the original dir string
            Dir$ = RIGHT$(Dir$, LEN(Dir$) - INSTR(Dir$, "\"))

        END IF

    WEND

    'if there was sub dirs, remove initial slash. (drive has it already)
    IF FinalPath$ <> "" THEN
        FinalPath$ = RIGHT$(FinalPath$, LEN(FinalPath$) - 1)
    END IF

    'add drive to final path.
    PrevDir$ = Drive$ + FinalPath$

    'set new base to prev dir found.
    NewBaseDirPath$ = PrevDir$
   

'If full path is specified, go there.
ELSE

    NewBaseDirPath$ = FullPath

END IF



NewBaseDirPath$ = RTRIM$(NewBaseDirPath$)

IF NewBaseDirPath$ <> "" THEN
    
    'if they didn't include drive, assume it's current drive
    IF INSTR(NewBaseDirPath$, ":\") = 0 THEN
        NewBaseDirPath$ = CurrentDrive + ":" + NewBaseDirPath$
    END IF

    DIM NewBaseDir AS Directory

    NewBaseDir.Id = 0
    NewBaseDir.ParentId = 0

    'TODO: set dir name.
    NewBaseDir.DirName = ""

    NewBaseDir.FullPath = UCASE$(NewBaseDirPath$)

    CurrentPath = RTRIM$(NewBaseDir.FullPath)
    
    'set current drive
    IF INSTR(CurrentPath, ":\") > 1 THEN
        CurrentDrive = LEFT$(CurrentPath, 1)
        'LOCATE 9, 50
        'PRINT "Current Drive: "; CurrentDrive
    END IF

    CALL SetSubDirs(NewBaseDir)
    CALL SetFileItems(NewBaseDir)

    CALL DrawScr(CurrentPath, Config)
    CALL DrawFileList(NONE, FileItems(), Config) 'none selected

ELSE
    'make sure current path is visible even if they didn't change
    LOCATE 3, 18
    PRINT CurrentPath

END IF

END SUB

DEFINT A-Z
FUNCTION CheckDirExists% (BaseDirPath$)

'check if basedirpath format "x:\" or "\" for root dir
'if dir is root dir, assume it's valid.
IF (LEN(BaseDirPath$) = 3 AND INSTR(BaseDirPath$, ":\") > 0) OR (LEN(BaseDirPath$) = 1 AND INSTR(BaseDirPath$, "\") > 0) THEN
    CheckDirExists% = TRUE
    EXIT FUNCTION
END IF


DirCommand$ = "DIR " + BaseDirPath$ + " > " + TEMPDIRFILENAME

LOCATE 4, 23
COLOR 7, 0
SHELL DirCommand$


'temp memory holder of file contents
DIM LineRead(MAXSUBDIRS) AS STRING
LinesRead% = 0

'regular mode, dir is assumed invalid.
IsValid% = FALSE

'dosbox mode is valid unless proven invalid.
IF Config.DosBoxCompMode THEN
    IsValid% = TRUE
END IF

SearchComplete% = FALSE

'read contents of temp file and place in memory.
OPEN TEMPDIRFILENAME FOR INPUT AS #1
WHILE NOT EOF(1) AND NOT SearchComplete%
    LINE INPUT #1, CurrentLine$


    'If doxbox mode, check for NOT FOUND in temp file results.
    IF Config.DosBoxCompMode THEN

        IF INSTR(UCASE$(CurrentLine$), "NOT FOUND") <> 0 THEN
            IsValid = FALSE%
            SearchComplete% = TRUE
        END IF

    'non-dosbox mode. check if relative "." dir exists in results.
    ELSE
        'if we found relative "." path, dir is valid.
        IF INSTR(CurrentLine$, ".") <> 0 THEN
            IsValid% = TRUE
        END IF
    END IF
WEND

CLOSE #1


CheckDirExists% = IsValid%

END FUNCTION

FUNCTION CheckPathCmdParam$

'checks if there is a directory path passed in the commandline parameters.
'if one exists, the default start directory will be that one.

'returns path if exists or defaults to C:\ if does not.

TempPath$ = "C:\"

IF INSTR(COMMAND$, ":\") > 0 THEN
    PathLoc% = INSTR(COMMAND$, ":\") - 2

    'make sure a path exists
    IF PathLoc% >= 0 THEN

        'get everything in parameters right of and including path.
        TempPath$ = RIGHT$(COMMAND$, LEN(COMMAND$) - PathLoc%)


        'remove everything after the first space after path
        IF INSTR(TempPath$, " ") > 0 THEN
            TempPath$ = LEFT$(TempPath$, INSTR(TempPath$, " "))
        END IF

        TempPath$ = RTRIM$(TempPath$)

        'remove dir slash if exists at the end.
        IF LEN(TempPath$) > 3 AND RIGHT$(TempPath$, 1) = "\" THEN
            TempPath$ = LEFT$(TempPath$, LEN(TempPath$) - 1)
        END IF

        'if dir doesn't exist, set them back to default.
        IF NOT CheckDirExists%(TempPath$) THEN
            COLOR 7, 0
            PRINT "Directory: "; TempPath$; " does not exist."
            PRINT "Defaulting start directory to C:\"
            PRINT
            PRINT "Please press any key..."

            DO: LOOP WHILE INKEY$ = ""

            TempPath$ = "C:\"
        END IF


    END IF
    

END IF

CheckPathCmdParam$ = TempPath$

END FUNCTION

SUB CheckXtMode

'If XT Compatibility mode parameter is passed the command line and is
'not currently set, set it and save the updated config. If it's not
'in the command line and is set, turn it off and save it.

IF INSTR(UCASE$(COMMAND$), XTCOMMANDPARAM + "=ON") > 0 THEN
    IF NOT Config.XtCompMode THEN
        Config.XtCompMode = TRUE
        CALL SaveConfig(Config)

        'XT Mode info pop up
        DIM XtModeText(14) AS STRING
        XtModeText(0) = "PC/XT Keyboard compatibility mode is now enabled."
        XtModeText(1) = "With this mode turned on, the application will"
        XtModeText(2) = "use an alternative slower method to capture the"
        XtModeText(3) = "keyboard input on the main screen as the faster"
        XtModeText(4) = "method does not work on original PC/XT keyboards"
        XtModeText(5) = ""
        XtModeText(6) = "The one major difference between modes from a user"
        XtModeText(7) = "experience is that `ESC' is used to toggle the"
        XtModeText(8) = "file menu instead of the `ALT' key."
        XtModeText(9) = ""
        XtModeText(10) = "To disable this mode, please use the command line"
        XtModeText(11) = "parameter at start up:"
        XtModeText(12) = "    /XT=OFF"
        XtModeText(13) = ""
        XtModeText(14) = "Press any key to continue."
        CALL DrawPopUp(12, 4, "PC/XT Keyboard Mode Turned On", XtModeText(), Config)
        SLEEP


    END IF

ELSEIF INSTR(UCASE$(COMMAND$), XTCOMMANDPARAM + "=OFF") > 0 THEN
    IF Config.XtCompMode THEN
        Config.XtCompMode = FALSE
        CALL SaveConfig(Config)

        'XT Mode disabled pop up
        DIM XtModeText(9) AS STRING
        XtModeText(0) = "PC/XT Keyboard compatibility mode is now disabled."
        XtModeText(1) = ""
        XtModeText(2) = "The regular keyboard input functions will be used"
        XtModeText(3) = "now to capture keyboard input. If the PC/XT"
        XtModeText(4) = "keyboard compatibilty mode needs to be turned back"
        XtModeText(5) = "on, use the following command line parameter:"
        XtModeText(6) = ""
        XtModeText(7) = "    /XT=ON"
        XtModeText(8) = ""
        XtModeText(9) = "Press any key to continue."
        CALL DrawPopUp(12, 4, "PC/XT Keyboard Mode Turned Off", XtModeText(), Config)
        SLEEP

    END IF
END IF


END SUB

SUB CopyFile (x AS INTEGER, y AS INTEGER, FileToCopy AS FileItem)

'copies a file to a destination directory

StartFileName$ = RTRIM$(FileToCopy.FileName) + "." + FileToCopy.FileExtension

DIM Body(6) AS STRING
Body(0) = SPACE$(47)
Body(1) = "    File to Copy: " + StartFileName$
Body(2) = "Current Location: " + CurrentPath
Body(3) = "Copy to Location: " + SPACE$(31)
Body(4) = ""
Body(5) = "[Enter] To Copy File To Copy Location"
Body(6) = "  [Esc] To Cancel"

CALL DrawPopUp(x, y, "Copy File", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + 4, x + 19
PRINT SPACE$(30)

i$ = ""

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)


    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z, _, : and \ characters in new path location.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z")) OR (i$ = ":") OR (i$ = "\") OR (i$ = "_") THEN
        
            'check length of file name and extension do not
            'go past max length.
            IF LEN(PathBuffer$) < 80 THEN
           
                PathBuffer$ = PathBuffer$ + i$
            END IF
           

        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            LOCATE y + 4, x + 19 + LEN(PathBuffer$) - 1
            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        LOCATE y + 4, x + 19
        PRINT PathBuffer$

    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% AND LEN(PathBuffer$) > 0 THEN

    NewBasePath$ = RTRIM$(PathBuffer$)

    'Not a great way to remove a slash if it's not for root dir
    'but it is what it is for now
    'TODO : add additional error checking.
    IF LEN(NewBasePath$) > 3 AND RIGHT$(NewBasePath$, 1) = "\" THEN
        NewBasePath$ = LEFT$(NewBasePath$, LEN(NewBasePath$) - 1)
    END IF

    NewLocation$ = NewBasePath$
  
    SHELL "COPY " + RTRIM$(FileToCopy.FullPath) + " " + NewLocation$ + " > COPYTEMP.TMP"

    OPEN "COPYTEMP.TMP" FOR INPUT AS #1
    WHILE NOT EOF(1)
        INPUT #1, CopyStatsTemp$
        CopyStats$ = CopyStats$ + CopyStatsTemp$
    WEND
    CLOSE #1

    FileCopied% = FALSE
    IF INSTR(UCASE$(CopyStats$), "COPIED") > 0 THEN
        FileCopied% = TRUE
    END IF

    DIM ConfirmBody(2) AS STRING

    IF FileCopied% THEN
        ConfirmBody(0) = StartFileName$ + " has been copied to " + NewLocation$
    ELSE
        ConfirmBody(0) = "ERROR: " + CopyStats$
    END IF

    ConfirmBody(1) = ""
    ConfirmBody(2) = " Press any key to continue"
    CALL DrawPopUp(14, 14, "File Copied", ConfirmBody(), Config)
    SLEEP
  
END IF



END SUB

SUB CreateNew (x AS INTEGER, y AS INTEGER, ItemType AS INTEGER)

CreateStr$ = "Enter name for new directory to create."

IF ItemType = ITEMTYPEFILE THEN
    CreateStr$ = "Enter name for new text file to create."
END IF


DIM Body(5) AS STRING
Body(0) = CreateStr$
Body(1) = ""
Body(2) = "Name:"
Body(3) = ""
Body(4) = "[Enter] To Create"
Body(5) = "  [Esc] To cancel"

CALL DrawPopUp(x, y, "Create New", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + 3, x + 6
PRINT SPACE$(33)


i$ = ""
isCleared% = FALSE

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)

    IF NOT isCleared% AND i$ <> "" THEN
        COLOR 0, 0
        LOCATE y + 3, x + 7
        PRINT SPACE$(30)

        isCleared% = TRUE
    END IF

    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z, _, and . characters in new name.
        'period only allowed in filename.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z") OR (i$ = "_")) OR (ItemType = ITEMTYPEFILE AND i$ = ".") THEN
           
            IF ItemType = ITEMTYPEFILE THEN
               
                'only allow one period in filename.
                IF i$ <> "." OR (i$ = "." AND INSTR(PathBuffer$, ".") = 0) THEN

                    'max length with file ext is 12 chars.
                    IF LEN(PathBuffer$) < 12 THEN
                        PathBuffer$ = PathBuffer$ + i$
                    ELSE
                        BEEP
                    END IF

                END IF

            'new dir
            ELSE
                'max dir name is 8 chars.
                IF LEN(PathBuffer$) < 8 THEN
                    PathBuffer$ = PathBuffer$ + i$
                ELSE
                    BEEP
                END IF


            END IF


        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            LOCATE y + 3, x + 7 + LEN(PathBuffer$) - 1
            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        LOCATE y + 3, x + 7
        PRINT PathBuffer$

    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% AND LEN(PathBuffer$) > 0 THEN

    DIM CreateNewBody(2) AS STRING

    CreateLocation$ = CurrentPath

    'add slash if missing from current path string
    IF RIGHT$(CreateLocation$, 1) <> "\" THEN
        CreateLocation$ = CreateLocation$ + "\"
    END IF


    IF ItemType = ITEMTYPEDIR THEN

        NewDir$ = CreateLocation$ + PathBuffer$
       
        MKDIR NewDir$

        CreateNewBody(0) = "Created new directory: " + GetDisplayPath(NewDir$)

    ELSE

        'if no ext provided, default to .txt
        IF INSTR(PathBuffer$, ".") = 0 THEN
            PathBuffer$ = PathBuffer$ + ".TXT"
        END IF

        NewFile$ = CreateLocation$ + PathBuffer$

        f% = FREEFILE

        ON ERROR GOTO ErrorHandler

        OPEN NewFile$ FOR OUTPUT AS #f%
        CLOSE #f%

        CreateNewBody(0) = "Created new text file: " + GetDisplayPath(NewFile$)


    END IF

    CreateNewBody(1) = ""
    CreateNewBody(2) = " Press any key to continue"

    CALL DrawPopUp(x, y + 8, "Created!", CreateNewBody(), Config)
    SLEEP


    'force a redraw of the current directory
    CALL ChangeDirectory(CurrentPath)


END IF


END SUB

SUB DeleteDirectory (Dir AS Directory)

'Make sure user isn't trying to delete a relative path.
DirToDelete$ = RTRIM$(Dir.DirName)
IF DirToDelete$ = ".." OR DirToDelete$ = "." THEN
    DIM ErrorBody(2) AS STRING
    ErrorBody(0) = "You cannot delete relative path: " + DirToDelete$
    ErrorBody(1) = ""
    ErrorBody(2) = "Press any key to continue"
    CALL DrawPopUp(10, 6, "Cannot Delete Directory", ErrorBody(), Config)
    SLEEP
    EXIT SUB
END IF

DIM Body(3) AS STRING
Body(0) = "Are you sure you want to delete directory: " + RTRIM$(Dir.DirName) + "?"
Body(1) = "WARNING: All files in the deleted directory will be lost!"
Body(2) = ""
Body(3) = "                    [Y]es [N]o"

CALL DrawPopUp(10, 6, "Delete Directory", Body(), Config)

'must clear directory before can be deleted...or use xcopy?

isDelete% = FALSE
i$ = ""
WHILE i$ = ""
    i$ = INKEY$
    IF UCASE$(i$) = "Y" THEN
        isDelete% = TRUE
    END IF
WEND

IF isDelete% THEN
    ON ERROR GOTO ErrorHandler

    DirToRemove$ = RTRIM$(Dir.FullPath)

    IF RIGHT$(DirToRemove$, 1) = "\" THEN
        DirToRemove$ = LEFT$(DirToRemove$, LEN(DirToRemove$) - 1)
    END IF

    'check dir for files and delete them if there are any.
    CALL SetFileItems(Dir)
    IF UBOUND(FileItems) > 0 THEN
        KILL DirToRemove$ + "\*.*"
    END IF

    'TODO : this should traverse the sub dirs and clear them out
    '       and then remove them. This currently doesn't work more
    '       than one level.

    RMDIR DirToRemove$

    'when returned, directory/fileitems should be reset to parent.
END IF



END SUB

SUB DeleteExtAction (Extension AS STRING)

'Removes extension action by file extension if exists

'IF IdxToDelete < UBOUND(ExtensionActions) THEN

    NewSize% = UBOUND(ExtensionActions) - 1
    IF NewSize% < 0 THEN
        NewSize% = 0
    END IF

    DIM TempExtActions(NewSize%) AS CustomExtensionAction

    'copy in existing entries except one to delete

    TempIdx% = 0
    ExtFound% = FALSE
    FOR i% = 0 TO UBOUND(ExtensionActions)

        'IF TempIdx% <> IdxToDelete THEN
       
        IF Extension <> ExtensionActions(i%).FileExtension THEN
            TempExtActions(TempIdx%).FileExtension = ExtensionActions(i%).FileExtension
            TempExtActions(TempIdx%).RunAction = ExtensionActions(i%).RunAction

            TempIdx% = TempIdx% + 1
        
        ELSE
            ExtFound% = TRUE
        END IF
    NEXT i%

    IF ExtFound% THEN
        CALL SaveExtActions(TempExtActions(), FALSE)
        CALL LoadExtActions
    END IF


'END IF

END SUB

SUB DeleteFile (File AS FileItem)

DIM Body(2) AS STRING
Body(0) = "Are you sure you want to delete file: " + RTRIM$(File.FileName) + "." + RTRIM$(File.FileExtension) + "?"
Body(1) = ""
Body(2) = "               [Y]es [N]o"

CALL DrawPopUp(10, 6, "Delete File", Body(), Config)

i$ = ""
WHILE i$ = ""
    i$ = INKEY$
WEND

IF UCASE$(i$) = "Y" THEN
    ON ERROR GOTO ErrorHandler
    delFile$ = RTRIM$(File.FullPath)
    KILL delFile$
END IF


END SUB

FUNCTION GetDisplayPath$ (PathToTrim AS STRING)

'trims the length of the path in the string to one that fits
'in a pop up if it's too long. This is to avoid screen x postition
'overflow in drawing the pop up data.

IF LEN(PathToTrim$) > 20 THEN
    PathToTrim$ = LEFT$(PathToTrim$, INSTR(PathToTrim$, ":") + 1) + "..." + RIGHT$(PathToTrim$, 13)
END IF

GetDisplayPath$ = PathToTrim$

END FUNCTION

FUNCTION GetXtKbScanCode%

'This function is called if XT keyboard mode it enabled. In this case,
'it will use INKEY$ instead of INP(96) to get the keyboard input. The
'keycode returned will be the INP(96) version of the scan code instead of
'the inkey one.


ScanCode% = UNSET

i$ = ""
i$ = INKEY$

IF i$ <> "" THEN

    SELECT CASE i$

        'esc
        CASE CHR$(27)
            ScanCode% = 56 'Returns ALT to toggle the menu.
                           'ALT can't be captured by INKEY$

        'tab
        CASE CHR$(9)
            ScanCode% = 15

        'tab
        CASE CHR$(9)
            ScanCode% = 15

        'O
        CASE "O", "o"
            ScanCode% = 24

        'enter
        CASE CHR$(13)
            ScanCode% = 28

        'F
        CASE "F", "f"
            ScanCode% = 33

        'H
        CASE "H", "h"
            ScanCode% = 35

        'ALT
        CASE CHR$(&H38)
            ScanCode% = 56

        'C
        CASE "C", "c"
            ScanCode% = 46


        'f1
        CASE CHR$(0) + CHR$(59)
            ScanCode% = 59

        'f2
        CASE CHR$(0) + CHR$(60)
            ScanCode% = 60

        'f3
        CASE CHR$(0) + CHR$(61)
            ScanCode% = 61
       
        'f4
        CASE CHR$(0) + CHR$(62)
            ScanCode% = 62

        'f5
        CASE CHR$(0) + CHR$(63)
            ScanCode% = 63

        'f6
        CASE CHR$(0) + CHR$(64)
            ScanCode% = 64

        'f7
        CASE CHR$(0) + CHR$(65)
            ScanCode% = 65

        'f8
        CASE CHR$(0) + CHR$(66)
            ScanCode% = 66

        'f9
        CASE CHR$(0) + CHR$(67)
            ScanCode% = 67

        'f10
        CASE CHR$(0) + CHR$(68)
            ScanCode% = 68

        'up
        CASE CHR$(0) + CHR$(72)
            ScanCode% = 72

        'pg up
        CASE CHR$(0) + CHR$(73)
            ScanCode = 73

        'P
        CASE "P", "p"
            ScanCode = 73 'acts as page up

        'left
        CASE CHR$(0) + CHR$(75)
            'unused
           
        'right
        CASE CHR$(0) + CHR$(77)
            'unused

        'down
        CASE CHR$(0) + CHR$(80)
            ScanCode% = 80

        'page down
        CASE CHR$(0) + CHR$(81)
            ScanCode% = 81

        CASE "M", "m"
            ScanCode% = 81 'acts as page down

        'del
        CASE CHR$(0) + CHR$(&H53)
            ScanCode% = 83

    END SELECT

END IF

GetXtKbScanCode% = ScanCode%


END FUNCTION

SUB HandleDirInfo (Dir AS Directory)

'TODO : add additional dir information

DIM Body(3) AS STRING
Body(0) = "Full Path: " + RTRIM$(Dir.FullPath)
Body(1) = " Dir Name: " + RTRIM$(Dir.DirName)
Body(2) = ""
Body(3) = "Press any key to continue"

CALL DrawPopUp(2, 5, "Directory Information", Body(), Config)

SLEEP

END SUB

SUB HandleDosBoxWarning

DIM Body(9) AS STRING
Body(0) = "The application is currently running in"
Body(1) = "DOSBox compatibility mode"
Body(2) = ""
Body(3) = "Please note that some directory and file"
Body(4) = "sorting functionality aren't available in"
Body(5) = "this mode due to limitations of the directory"
Body(6) = "functions in the DOS emulator."
Body(7) = ""
Body(8) = "           [O]kay   [D]on't show this again"

CALL DrawPopUp(15, 6, "DOSBox Compatibility Mode Warning", Body(), Config)

WarnInput$ = ""
WHILE UCASE$(WarnInput$) <> "O" AND UCASE$(WarnInput$) <> "D"
    WarnInput$ = INKEY$
WEND


'if they don't want to see again, save that in their config.
IF UCASE$(WarnInput$) = "D" THEN
    Config.ShowDosBoxWarning = FALSE
    CALL SaveConfig(Config)
END IF

END SUB

SUB HandleFileInfo (Item AS FileItem)

'TODO : add additional file information

DIM Body(3) AS STRING
Body(0) = "Full Path: " + RTRIM$(Item.FullPath)
Body(1) = "File Name: " + RTRIM$(Item.FileName) + "." + RTRIM$(Item.FileExtension)
Body(2) = ""
Body(3) = "Press any key to continue"

CALL DrawPopUp(2, 5, "File Information", Body(), Config)

SLEEP

END SUB

FUNCTION HandleFileMenu% (CurrentArea AS INTEGER)

IsStillRunning% = TRUE


'TODO : QB NAME function can rename files and move files.

i$ = ""
WHILE i$ = ""
    i$ = INKEY$
WEND

SELECT CASE UCASE$(i$)

    CASE "N"
        CALL CreateNew(15, 6, CurrentArea)

    CASE "O"
        CALL OpenLocation(15, 6)

    CASE "D"
        IF CurrentArea = AREADIR THEN
            CALL DeleteDirectory(SubDirs(SelectedDirIdx))
            SelectedDirIdx = 0
        ELSE
            CALL DeleteFile(FileItems(SelectedFileIdx))
        END IF

        'make sure idx is still valid if deleted last
        'entry in the file list.
        IF SelectedFileIdx >= UBOUND(FileItems) THEN
            SelectedFileIdx = UBOUND(FileItems) - 1
        END IF

        'TODO : fix directory draw so it's correct.
        UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)

        CALL ChangeDirectory(CurrentPath)

    CASE "R"
        IF CurrentArea = AREAFILE THEN
            CALL RenameFile(10, 6, FileItems(SelectedFileIdx))

            'TODO : fix directory draw so it's correct.
            UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)

            CALL ChangeDirectory(CurrentPath)
        END IF

    CASE "M"
        IF CurrentArea = AREAFILE THEN
            CALL MoveFile(2, 5, FileItems(SelectedFileIdx))

            'TODO : fix directory draw so it's correct.
            UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)

            CALL ChangeDirectory(CurrentPath)
        END IF

    CASE "C"
        IF CurrentArea = AREAFILE THEN
            CALL CopyFile(2, 5, FileItems(SelectedFileIdx))

            'TODO : fix directory draw so it's correct.
            UNUSED = DrawDirectoryList(CurrentDisplayIdx, NONE, SubDirs(), Config)

            CALL ChangeDirectory(CurrentPath)
        END IF



    CASE "X"
        
        'display exit confirmation message

        DIM ExitBody(1) AS STRING
        ExitBody(0) = "Are you sure you want to exit?"
        ExitBody(1) = "       [Y]es  [N]o"
        CALL DrawPopUp(22, 8, "Exit?", ExitBody(), Config)
        exit$ = ""
        WHILE exit$ = ""
            exit$ = INKEY$
            IF UCASE$(exit$) = "Y" THEN
                IsStillRunning% = FALSE
            END IF
        WEND

END SELECT

HandleFileMenu = IsStillRunning%

END FUNCTION

SUB HandleHelpMenu

'Help menu is simple so all action choices are
'placed here instead of branching to related subs.

i$ = ""
WHILE i$ = ""
    i$ = INKEY$
WEND

SELECT CASE UCASE$(i$)

    CASE "A"
        DIM Body(12) AS STRING
        Body(0) = "NE File Util is a file management utility"
        Body(1) = "used to manage your files and directories"
        Body(2) = "on your hard drive. This application can"
        Body(3) = "also run your programs directly or with"
        Body(4) = "custom launching options or parameters."
        Body(5) = "Text files can also be edited or viewed."
        Body(6) = ""
        Body(7) = "Written by: Erik Eriksen"
        Body(8) = "   Version: " + VER
        Body(9) = "Build Date: " + BUILDDATE
        Body(10) = "       Web: http://eriks.servehttp.com"
        Body(11) = ""
        Body(12) = "                Press any key to return"


        CALL DrawPopUp(20, 5, "About", Body(), Config)

        SLEEP

    CASE "H"
        DIM Body(19) AS STRING
        Body(0) = "             Helpful Command List:"
        Body(1) = "            "
        Body(2) = " F1 - View selectd file or directory information."
        Body(3) = " F2 - Rename selected file."
        Body(4) = " F5 - Run selected file with custom parameters."
        Body(5) = " F7 - Move currently selected file to a new directory."
        Body(6) = " F8 - Copy currently selected file to a another directory."
        Body(7) = "F10 - Shortcut to change directory in menu bar."
        Body(8) = "ENTER - Enter into directory or run an selected file."
        Body(9) = "TAB - Select between files and directories."
        Body(10) = "M or Pg Down - Scroll to next page in selected list."
        Body(11) = "P or Pg Up - Scroll to previous page in selected list."
        Body(12) = "ALT - Toggle file menus (Not in XT keyboard comp mode)"
        Body(13) = "ESC - Toggle file menus (In XT keyboard comp mode)"
        Body(14) = "DEL - Delete selected file or directory."
        Body(15) = ""
        Body(16) = "Command Line Parameters:"
        Body(17) = "  Please use /? at the command line to view available options."
        Body(18) = ""
        Body(19) = "                Press any key to return"

        CALL DrawPopUp(10, 2, "Help", Body(), Config)

        SLEEP


END SELECT





END SUB

SUB HandleOptionsMenu


i$ = ""
WHILE i$ = ""
    i$ = INKEY$
WEND

SELECT CASE UCASE$(i$)

    CASE "H"
        CALL ToggleHiddenFiles

    CASE "R"
        CALL SetRunOptions(1, 3)

    CASE "T"
        CALL SetEditorPath(15, 8)

    CASE "M"
       CALL ToggleDosBoxMode(5, 11)

    CASE "S"
        CALL SetSortOrder(13, 3)

    CASE "D"
        CALL SetResolution(13, 3)

    CASE "C"
        CALL SetColorScheme(13, 3)

END SELECT



END SUB

SUB LoadConfig

ON ERROR GOTO ErrorHandler

IF NOT FileExists(CONFIGFILENAME) THEN
    PRINT "Config file not found. New one will be generated"
    CALL SetDefaultConfig
    CALL SaveConfig(Config)
END IF



OPEN CONFIGFILENAME FOR INPUT AS #1

    INPUT #1, Config.DosVersion
    INPUT #1, Config.NumRows
    INPUT #1, Config.NumColumns
    INPUT #1, Config.EditPath
    INPUT #1, Config.DosBoxCompMode
    INPUT #1, Config.XtCompMode
    INPUT #1, Config.TitleBarFgColor
    INPUT #1, Config.TitleBarBgColor
    INPUT #1, Config.MenuBarFgColor
    INPUT #1, Config.MenuBarBgColor
    INPUT #1, Config.PopUpBgColor
    INPUT #1, Config.PopUpFgColor
    INPUT #1, Config.MainBgColor
    INPUT #1, Config.MainFgColor
    INPUT #1, Config.MainSelectedColor
    INPUT #1, Config.ShowDosBoxWarning
    INPUT #1, Config.ShowHiddenFiles
    INPUT #1, Config.FileSortOrder
    INPUT #1, Config.MenuDisabledFgColor
    INPUT #1, Config.ColorSchemeId

CLOSE #1



END SUB

SUB LoadExtActions

ON ERROR GOTO ErrorHandler

IF NOT FileExists(EXTACTIONFILENAME) THEN
    PRINT "Custom extension run action config not found. New one will be generated"
    CALL SaveExtActions(ExtensionActions(), TRUE)
END IF


DIM TempContents(200) AS STRING
CurrentLine% = 0

OPEN EXTACTIONFILENAME FOR INPUT AS #1

    WHILE NOT EOF(1)
        IF CurrentLine% < UBOUND(TempContents) THEN
            LINE INPUT #1, CurrentLine$

            'make sure line at least attempts to be a valid line and
            'is not a comment. Additional parsing will be done below.

            IF CurrentLine$ <> "" AND INSTR(CurrentLine$, "=") > 0 AND INSTR(CurrentLine$, "#") = 0 THEN
                
                'if only has "=" in line, length is 3 and invalid.
                'skip those lines.

                CurLineTrim$ = LTRIM$(RTRIM$(CurrentLine$))

                IF LEN(CurLineTrim$) <> 3 THEN
                    
                    TempContents(CurrentLine%) = CurrentLine$
                    CurrentLine% = CurrentLine% + 1
                END IF
               
            END IF
        END IF
    WEND
CLOSE #1
      
Size% = CurrentLine% - 1
IF Size% < 0 THEN
    Size% = 0
END IF

REDIM ExtensionActions(Size%) AS CustomExtensionAction

FOR i% = 0 TO UBOUND(ExtensionActions)

    'lines too short to be valid are ignored.
    IF LEN(TempContents(i%)) >= 4 THEN


        'this is a fun (sarcastic) string splitting and parsing of the config
        'file.... *vomits*

        FileExtension$ = LEFT$(TempContents(i%), 4)
        FileExtension$ = RIGHT$(FileExtension$, 3)

        RunAction$ = RIGHT$(TempContents(i%), LEN(TempContents(i%)) - 5)
        RunAction$ = LEFT$(RunAction$, LEN(RunAction$) - 1)

        'After getting the correct parts of the string, then trim
        'any white spaces off each part.

        FileExtension$ = LTRIM$(RTRIM$(FileExtension$))
        RunAction$ = LTRIM$(RTRIM$(RunAction$))

        IF FileExtension$ <> "" AND RunAction$ <> "" THEN
            ExtensionActions(i%).FileExtension = FileExtension$
            ExtensionActions(i%).RunAction = RunAction$
            'ExtensionActions(i%).IsValid = TRUE
        END IF
        
    END IF
NEXT i%

END SUB

SUB MoveFile (x AS INTEGER, y AS INTEGER, FileToMove AS FileItem)

'Moves a file from one directory to another.

StartFileName$ = RTRIM$(FileToMove.FileName) + "." + FileToMove.FileExtension

DIM Body(6) AS STRING
Body(0) = SPACE$(47)
Body(1) = "    File to Move: " + StartFileName$
Body(2) = "Current Location: " + CurrentPath
Body(3) = "    New Location: " + SPACE$(31)
Body(4) = ""
Body(5) = "[Enter] To Move File To New Location"
Body(6) = "  [Esc] To Cancel"

CALL DrawPopUp(x, y, "Move File", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + 4, x + 19
PRINT SPACE$(30)

i$ = ""

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)


    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z, _, : and \ characters in new path location.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z")) OR (i$ = ":") OR (i$ = "\") OR (i$ = "_") THEN
         
            'check length of file name and extension do not
            'go past max length.
            IF LEN(PathBuffer$) < 80 THEN
            
                PathBuffer$ = PathBuffer$ + i$
            END IF
            

        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            LOCATE y + 4, x + 19 + LEN(PathBuffer$) - 1
            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        LOCATE y + 4, x + 19
        PRINT PathBuffer$

    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% AND LEN(PathBuffer$) > 0 THEN

    NewBasePath$ = RTRIM$(PathBuffer$)

    IF RIGHT$(NewBasePath$, 1) <> "\" THEN
        NewBasePath$ = NewBasePath$ + "\"
    END IF

    NewLocation$ = NewBasePath$ + RTRIM$(StartFileName$)
    
    NAME RTRIM$(FileToMove.FullPath) AS NewLocation$

    DIM ConfirmBody(2) AS STRING
    ConfirmBody(0) = StartFileName$ + " has been moved to " + NewLocation$
    ConfirmBody(1) = ""
    ConfirmBody(2) = " Press any key to continue"
    CALL DrawPopUp(14, 14, "File Moved", ConfirmBody(), Config)
    SLEEP
   
END IF


END SUB

SUB OpenLocation (x AS INTEGER, y AS INTEGER)

'Opens either a directory or attempts to open a file
'if a file is passed to the popup window.

OpenStr$ = "Enter file path or directory to open:"

DIM Body(5) AS STRING
Body(0) = OpenStr$
Body(1) = ""
Body(2) = "Path:"
Body(3) = ""
Body(4) = "[Enter] To Open"
Body(5) = "  [Esc] To Cancel"

CALL DrawPopUp(x, y, "Open File or Directory", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + 3, x + 6
PRINT SPACE$(32)


i$ = ""
isCleared% = FALSE

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)

    IF NOT isCleared% AND i$ <> "" THEN
        COLOR 0, 0
        LOCATE y + 3, x + 7
        PRINT SPACE$(30)

        isCleared% = TRUE
    END IF

    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z, and . characters in new name.
        'period only allowed in filename.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z")) OR (i$ = ".") OR (i$ = ":") OR (i$ = "\") THEN
            PathBuffer$ = PathBuffer$ + i$

        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            LOCATE y + 3, x + 7 + LEN(PathBuffer$) - 1
            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        LOCATE y + 3, x + 7
        PRINT PathBuffer$

    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% AND LEN(PathBuffer$) > 0 THEN


    IF LEN(PathBuffer$) > 3 THEN
   
        IF INSTR(RIGHT$(PathBuffer$, LEN(PathBuffer$) - 3), ".") > 0 THEN
  
            'TODO : maybe find a way to use RunFile SUB to do this?

            CLS
            SHELL PathBuffer$

            PRINT
            PRINT "Press ENTER to return to NE File Util..."

            return$ = ""
            DO WHILE return$ <> CHR$(13)
                return$ = INKEY$
            LOOP

            CLS


        ELSE
            'open the dir if doesn't look like a file
            CALL ChangeDirectory(PathBuffer$)
        END IF

    ELSE
        'yeah this is gross but QB doesn't pass the IF block on first
        'first true on an OR like other languages...
        'open the dir if doesn't look like a file
        CALL ChangeDirectory(PathBuffer$)
    END IF


END IF


END SUB

SUB PrintCommandHelp

'If help command line parameter is passed, the command line parameter
'help will be displayed and the program will exit.

IF INSTR(COMMAND$, HELPCOMMANDPARAM) > 0 THEN
    
    PRINT "FILEUTIL is a text based user interface that helps organize and manage"
    PRINT "the files on your hard drive or external drives."
    PRINT
    PRINT "FILEUTIL ["; HELPCOMMANDPARAM; "] ["; RESETCOMMANDPARAM; "] ["; XTCOMMANDPARAM; "=ON|"; XTCOMMANDPARAM; "=OFF] [drive:\][path]"
    PRINT
    PRINT "  "; HELPCOMMANDPARAM; SPACE$(10); "Displays this help screen."
    PRINT "  "; RESETCOMMANDPARAM; SPACE$(6); "Deletes all current temp files and configurations and "
    PRINT SPACE$(14); "replaces them with their default values."
    PRINT "  "; XTCOMMANDPARAM; "=ON"; SPACE$(6); "Turns on PC/XT keyboard compatibility mode for legacy devices."
    PRINT "  "; XTCOMMANDPARAM; "=OFF"; SPACE$(5); "Turns off PC/XT keyboard compatibility mode for legacy devices."
    PRINT "  drive:\     Starts application directory view on that drive. (Default C:\)"
    PRINT "  path        Sets the path on the directory to open (optional)"
    PRINT
    PRINT "Example: FILEUTIL C:\DOS will start the application viewing the DOS directory."
    PRINT
    PRINT "NE FILEUTIL is written by Erik Eriksen."
    PRINT "Version: "; VER; " (Build Date: "; BUILDDATE; ")"
    PRINT "    Web: http://eriks.servehttp.com"
    PRINT
    END

END IF

END SUB

DEFSNG A-Z
SUB PrintDirInfo (Dir AS Directory)

PRINT "       Id: "; Dir.Id
PRINT "Parent Id: "; Dir.ParentId
PRINT "     Name: "; Dir.DirName
PRINT "Full Path: "; RTRIM$(Dir.FullPath)

END SUB

DEFINT A-Z
SUB RenameFile (x AS INTEGER, y AS INTEGER, FileToRename AS FileItem)

'renames a selected file to a new name.

StartFileName$ = RTRIM$(FileToRename.FileName) + "." + FileToRename.FileExtension

DIM Body(5) AS STRING
Body(0) = SPACE$(26)
Body(1) = "Original Name: " + StartFileName$
Body(2) = "     New Name: "
Body(3) = ""
Body(4) = "[Enter] To Rename File to New Name"
Body(5) = "  [Esc] To Cancel"

CALL DrawPopUp(x, y, "Rename File", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + 3, x + 16
PRINT SPACE$(12)

i$ = ""

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)


    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z, _, and . characters in new name.
        'period only allowed in filename.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z")) OR (i$ = ".") OR (i$ = "_") THEN
           
            'only allow one period in the filename.
            IF (i$ = "." AND INSTR(PathBuffer$, ".") = 0) OR i$ <> "." THEN
              
                'check length of file name and extension do not
                'go past max length.
                PeriodLoc% = INSTR(PathBuffer$, ".")
                IF (PeriodLoc% = 0 AND LEN(PathBuffer$) < 8) OR (PeriodLoc% = 0 AND LEN(PathBuffer$) = 8 AND i$ = ".") OR (PeriodLoc% > 0 AND LEN(PathBuffer$) - PeriodLoc% < 3) THEN
                    PathBuffer$ = PathBuffer$ + i$
                END IF
            END IF

        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            LOCATE y + 3, x + 16 + LEN(PathBuffer$) - 1
            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        LOCATE y + 3, x + 16
        PRINT PathBuffer$

    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% AND LEN(PathBuffer$) > 0 THEN

    BasePath$ = CurrentPath

    IF RIGHT$(BasePath$, 1) <> "\" THEN
        BasePath$ = BasePath$ + "\"
    END IF

    NewName$ = BasePath$ + RTRIM$(PathBuffer$)
     
    'basic check that full path has something other than
    'just the drive.
    IF LEN(RTRIM$(FileToRename.FullPath)) > 3 THEN
        NAME RTRIM$(FileToRename.FullPath) AS NewName$

        DIM ConfirmBody(2) AS STRING
        ConfirmBody(0) = StartFileName$ + " has been renamed to " + RTRIM$(PathBuffer$)
        ConfirmBody(1) = ""
        ConfirmBody(2) = " Press any key to continue"
        CALL DrawPopUp(14, 14, "File Renamed", ConfirmBody(), Config)
        SLEEP

    END IF


END IF


END SUB

SUB ResetConfigData

'Checks if the reset command line parameter was passed. If it was,
'all of the temp files and config data files will be deleted. The
'config files will be replaced with their default versions on next
'application start.

IF INSTR(UCASE$(COMMAND$), RESETCOMMANDPARAM) > 0 THEN

    PRINT "NE FILEUTIL (Ver: "; VER; " Build date: "; BUILDDATE; ")"
    PRINT "Reset Temp File and Configuration data"
    PRINT

    PRINT "Are you sure you want to reset all FILEUTIL configurations as well"
    INPUT "as any temp data files? [Y/N]: ", ResetConfirm$

    IF UCASE$(ResetConfirm$) = "Y" THEN

        PRINT
        PRINT "Deleting configuration files:"
  
        PRINT "Deleting "; CONFIGFILENAME; "..."
        KILL CONFIGFILENAME
 
        PRINT "Deleting "; EXTACTIONFILENAME; "..."
        KILL EXTACTIONFILENAME

        PRINT
        PRINT "Deleting temporary data files:"
   
        PRINT "Deleting "; TEMPVERFILENAME; "..."
        KILL TEMPVERFILENAME

        PRINT "Deleting "; TEMPDIRFILENAME; "..."
        KILL TEMPDIRFILENAME
   
        PRINT "Deleting "; TEMPFILEFILENAME; "..."
        KILL TEMPFILEFILENAME

        PRINT
        PRINT "Done."
        PRINT
        PRINT "Please restart the application without the "; RESETCOMMANDPARAM;
        PRINT "command parameter to continue using the appliction with the default."
        PRINT "configuration values."
        PRINT
        END

    ELSE
        PRINT "Temp file and configuration reset aborted."
    END IF

    END

END IF

END SUB

SUB RunFile (SelectedIdx AS INTEGER)

CALL ClearKbBuffer

'Runs the selected file list idx. If EXE/BAT/COM
'app will launch. If other, will ask what to do

IF SelectedIdx < UBOUND(FileItems) THEN

    RunItem$ = RTRIM$(FileItems(SelectedIdx).FullPath)
    Extension$ = FileItems(SelectedIdx).FileExtension

    CustomActionFound% = FALSE
    CustomRunAction$ = ""
    FOR i% = 0 TO UBOUND(ExtensionActions)
        IF ExtensionActions(i%).FileExtension = Extension$ THEN
            CustomActionFound% = TRUE
            CustomRunAction$ = RTRIM$(ExtensionActions(i%).RunAction)
        END IF
    NEXT i%

    'run custom action on extension if one is configured with highest
    'priority.
    IF CustomActionFound% THEN

        'TODO : use placehold to allow user to configure where in the custom
        '       run actio string the filename gets placed.
        CLS
        LOCATE 1, 1
        COLOR 7, 0
        PRINT "Found custom action for ext: "; Extension$; " act: "; CustomRunAction$; " "; RunItem$
        SHELL CustomRunAction$ + " " + RunItem$

    ELSEIF Extension$ = "EXE" OR Extension$ = "COM" THEN

        CLS
        LOCATE 1, 1
        COLOR 7, 0
        PRINT "Launching: "; RunItem$

        SHELL RunItem$

    ELSEIF Extension$ = "TXT" OR Extension$ = "LOG" OR Extension$ = "DOC" OR Extension$ = "INI" THEN
        'run edit or view

       
        DIM Body(2) AS STRING
        Body(1) = "Edit, view or cancel? [E/V/C]"
        CALL DrawPopUp(18, 6, "Opening Text Document", Body(), Config)
       
        COLOR 7, 0
        LOCATE 1, 1

        edit$ = ""
        WHILE UCASE$(edit$) <> "E" AND UCASE$(edit$) <> "V" AND UCASE$(edit$) <> "C"
            edit$ = INKEY$
        WEND

        IF UCASE$(edit$) = "E" THEN
            CLS
            SHELL RTRIM$(Config.EditPath) + " " + RunItem$
        ELSEIF UCASE$(edit$) = "V" THEN
            CLS
            SHELL "TYPE " + RunItem$ + " | MORE"
            PRINT
            
        ELSE
            'nothing to do
            EXIT SUB
        END IF

       
    ELSEIF Extension$ = "BAT" THEN
        'ask to run or edit

        DIM Body(2) AS STRING
        Body(1) = "Edit, run, view or cancel? [E/R/V/C]"

        CALL DrawPopUp(15, 6, "Opening Batch File", Body(), Config)
       
        COLOR 7, 0
        LOCATE 1, 1

        edit$ = ""
        WHILE UCASE$(edit$) <> "E" AND UCASE$(edit$) <> "R" AND UCASE$(edit$) <> "V" AND UCASE$(edit$) <> "C"
            edit$ = INKEY$
        WEND

        
        IF UCASE$(edit$) = "E" THEN
            CLS
            SHELL RTRIM$(Config.EditPath) + " " + RunItem$
        ELSEIF UCASE$(edit$) = "R" THEN
            CLS
            PRINT "Launching: "; RunItem$
            SHELL RunItem$
        ELSEIF UCASE$(edit$) = "V" THEN
            CLS
            SHELL "TYPE " + RunItem$ + " | MORE "
            PRINT
        ELSE
            'nothing to do
            EXIT SUB
        END IF


    ELSE
        CLS
        LOCATE 1, 1
        COLOR 7, 0
        PRINT "Cannot run file of type: "; Extension$
    END IF

END IF


PRINT
PRINT "Press ENTER to return to NE File Util..."

return$ = ""
DO WHILE return$ <> CHR$(13)
    return$ = INKEY$
LOOP


END SUB

SUB RunFileWithParam (SelectedIdx AS INTEGER)

CALL ClearKbBuffer

'Runs the selected file list idx.
'will display pop up asking for command params to run with

IF SelectedIdx < UBOUND(FileItems) THEN

    RunItem$ = RTRIM$(FileItems(SelectedIdx).FullPath)
    Extension$ = FileItems(SelectedIdx).FileExtension

    'check for custom run action. Add it to run item if found.
    FOR i% = 0 TO UBOUND(ExtensionActions)
        IF ExtensionActions(i%).FileExtension = Extension$ THEN
            RunItem$ = RTRIM$(ExtensionActions(i%).RunAction) + " " + RunItem$
        END IF
    NEXT i%

    RunItemCopy$ = RunItem$
    RunItemToDisplay$ = GetDisplayPath(RunItem$)
   
    DIM Body(5) AS STRING
    Body(0) = "Enter parameters to launch this file. Leaving the field"
    Body(1) = "below blank will cancel running the selected file and"
    Body(2) = "return you to the main screen."
    Body(3) = ""
    Body(4) = RunItemToDisplay$ + SPACE$(26)
    Body(5) = ""
   
    CALL DrawPopUp(5, 6, "Run With Parameters", Body(), Config)
   
    COLOR 7, 0
    LOCATE 11, 6 + LEN(RunItemToDisplay$) + 1
    PRINT SPACE$(25)
    LOCATE 11, 6 + LEN(RunItemToDisplay$) + 1
    INPUT "", Parameters$

    'only run if something was passed as a parmeter.
    IF LTRIM$(RTRIM$(Parameters$)) <> "" THEN
        CLS
        COLOR 7, 0
        LOCATE 1, 1
        PRINT "Launching: "; RunItemCopy$; " "; Parameters$
   
        SHELL RunItemCopy$ + " " + Parameters$

        PRINT
        PRINT "Press ENTER to return to NE File Util..."

        return$ = ""
        DO WHILE return$ <> CHR$(13)
            return$ = INKEY$
        LOOP

    END IF

END IF


END SUB

SUB SaveConfig (ConfigToSave AS Configuration)

ON ERROR GOTO ErrorHandler

OPEN CONFIGFILENAME FOR OUTPUT AS #1

    WRITE #1, ConfigToSave.DosVersion
    WRITE #1, ConfigToSave.NumRows
    WRITE #1, ConfigToSave.NumColumns
    WRITE #1, ConfigToSave.EditPath
    WRITE #1, ConfigToSave.DosBoxCompMode
    WRITE #1, ConfigToSave.XtCompMode
    WRITE #1, ConfigToSave.TitleBarFgColor
    WRITE #1, ConfigToSave.TitleBarBgColor
    WRITE #1, ConfigToSave.MenuBarFgColor
    WRITE #1, ConfigToSave.MenuBarBgColor
    WRITE #1, ConfigToSave.PopUpBgColor
    WRITE #1, ConfigToSave.PopUpFgColor
    WRITE #1, ConfigToSave.MainBgColor
    WRITE #1, ConfigToSave.MainFgColor
    WRITE #1, ConfigToSave.MainSelectedColor
    WRITE #1, ConfigToSave.ShowDosBoxWarning
    WRITE #1, ConfigToSave.ShowHiddenFiles
    WRITE #1, ConfigToSave.FileSortOrder
    WRITE #1, ConfigToSave.MenuDisabledFgColor
    WRITE #1, ConfigToSave.ColorSchemeId

CLOSE #1

END SUB

SUB SaveExtActions (ExtActionsToSave() AS CustomExtensionAction, IsNewFile AS INTEGER)

ON ERROR GOTO ErrorHandler

OPEN EXTACTIONFILENAME FOR OUTPUT AS #1
   
    WRITE #1, "# File run association command line actions by extension."
    WRITE #1, "# Last Updated: " + DATE$ + " " + RTRIM$(TIME$)

    IF NOT IsNewFile THEN

        FOR i% = 0 TO UBOUND(ExtActionsToSave)
            
            WRITE #1, ExtActionsToSave(i%).FileExtension + "=" + ExtActionsToSave(i%).RunAction
        
        NEXT i%
    END IF

CLOSE #1


END SUB

SUB SetColorScheme (x AS INTEGER, y AS INTEGER)

'sets color scheme for application and saves it to the
'config based on user's input.


xOffset% = 3
yOffset% = 2
windowX% = x
windowY% = y

DIM Body(9) AS STRING
Body(0) = "Please select a color scheme:"
Body(1) = " [ ] Clean 'n Green"
Body(2) = " [ ] Some Kind Of Blue"
Body(3) = " [ ] Red Devil"
Body(4) = " [ ] High Contrast"
Body(5) = " [ ] Monochrome"
Body(6) = ""
Body(7) = "Arrow keys to move between choices."
Body(8) = "Press [Space] to select, [Enter] to save changes"
Body(9) = "      [Esc] to cancel"

CALL DrawPopUp(windowX%, windowY%, "Set Color Scheme", Body(), Config)

ChoiceIdx% = Config.ColorSchemeId

'put a check next to current settings.
LOCATE windowY% + yOffset% + ChoiceIdx%, windowX% + xOffset%
COLOR Config.PopUpFgColor, Config.PopUpBgColor
PRINT CHR$(251)

'set start default selected option.
Selected% = 0
LOCATE windowY% + yOffset% + Selected%, windowX% + xOffset%
COLOR Config.PopUpBgColor, Config.PopUpFgColor

IF Selected% = ChoiceIdx% THEN
    PRINT CHR$(251)
ELSE
    PRINT " "
END IF



' get user input
i$ = ""
redraw% = FALSE
SaveSettings% = FALSE
WHILE i$ <> CHR$(13) AND i$ <> CHR$(27)

    i$ = UCASE$(INKEY$)

    'up
    IF i$ = CHR$(0) + CHR$(72) THEN
        IF Selected% > 0 THEN
            Selected% = Selected% - 1
            redraw% = TRUE
        END IF


    'down
    ELSEIF i$ = CHR$(0) + CHR$(80) THEN
        IF Selected% < 4 THEN
            Selected% = Selected% + 1
            redraw% = TRUE
        END IF

    'space - selected choice.
    ELSEIF i$ = " " THEN
        ChoiceIdx% = Selected%
        redraw% = TRUE


    'enter for save
    ELSEIF i$ = CHR$(13) THEN
        SaveSettings% = TRUE
    END IF

    'if moved, redraw selections.
    IF redraw% THEN
        redraw% = FALSE

        FOR i% = 0 TO 4

            LOCATE windowY% + yOffset% + i%, windowX% + xOffset%
            IF i% = Selected% THEN
                COLOR Config.PopUpBgColor, Config.PopUpFgColor
            ELSE
                COLOR Config.PopUpFgColor, Config.PopUpBgColor
            END IF
          
            IF i% = ChoiceIdx% THEN
                PRINT CHR$(251)
            ELSE
                PRINT " "
            END IF

        NEXT i%

    END IF


WEND

'save settings if needed and set new resolution.
IF SaveSettings% THEN

    IF ChoiceIdx% <> Config.ColorSchemeId THEN

        Config.ColorSchemeId% = ChoiceIdx%

        SELECT CASE ChoiceIdx%

            CASE 0 'green
                Config.TitleBarFgColor = 15
                Config.TitleBarBgColor = 2
                Config.MenuBarFgColor = 0
                Config.MenuBarBgColor = 7
                Config.PopUpBgColor = 7
                Config.PopUpFgColor = 0
                Config.MainBgColor = 0
                Config.MainFgColor = 7
                Config.MainSelectedColor = 10
                Config.MenuDisabledFgColor = 8

            CASE 1 'blue
                Config.TitleBarFgColor = 15
                Config.TitleBarBgColor = 1
                Config.MenuBarFgColor = 15
                Config.MenuBarBgColor = 3
                Config.PopUpBgColor = 7
                Config.PopUpFgColor = 0
                Config.MainBgColor = 15
                Config.MainFgColor = 0
                Config.MainSelectedColor = 1
                Config.MenuDisabledFgColor = 8

            CASE 2 'red
                Config.TitleBarFgColor = 15
                Config.TitleBarBgColor = 4
                Config.MenuBarFgColor = 0
                Config.MenuBarBgColor = 7
                Config.PopUpBgColor = 7
                Config.PopUpFgColor = 0
                Config.MainBgColor = 0
                Config.MainFgColor = 12
                Config.MainSelectedColor = 12
                Config.MenuDisabledFgColor = 8
                
            CASE 3 'high contrast
                Config.TitleBarFgColor = 15
                Config.TitleBarBgColor = 13
                Config.MenuBarFgColor = 15
                Config.MenuBarBgColor = 2
                Config.PopUpBgColor = 4
                Config.PopUpFgColor = 15
                Config.MainBgColor = 0
                Config.MainFgColor = 15
                Config.MainSelectedColor = 5
                Config.MenuDisabledFgColor = 0

            CASE 4 'monochrome
                Config.TitleBarFgColor = 0
                Config.TitleBarBgColor = 7
                Config.MenuBarFgColor = 7
                Config.MenuBarBgColor = 0
                Config.PopUpBgColor = 7
                Config.PopUpFgColor = 0
                Config.MainBgColor = 0
                Config.MainFgColor = 7
                Config.MainSelectedColor = 7
                Config.MenuDisabledFgColor = 8

        END SELECT

        CALL SaveConfig(Config)
       
        'TODO : default dir should be base drive of where app was launched.
        CALL DrawScr(CurrentPath, Config)
        CALL ChangeDirectory("C:\")

    END IF

END IF


END SUB

SUB SetDefaultConfig

'Returns default values to use when no config exists.

DIM TempConfig AS Configuration

TempConfig.DosVersion = GetDosVersion$

IF INSTR(UCASE$(TempConfig.DosVersion), DOSBOXVERSUBSTR) THEN
    TempConfig.DosBoxCompMode = TRUE
    TempConfig.ShowDosBoxWarning = TRUE
ELSE
    TempConfig.DosBoxCompMode = FALSE
    TempConfig.ShowDosBoxWarning = FALSE
END IF


TempConfig.NumRows = 25
TempConfig.NumColumns = 80
TempConfig.EditPath = "C:\DOS\EDIT.COM"
TempConfig.XtCompMode = FALSE
TempConfig.TitleBarFgColor = 15
TempConfig.TitleBarBgColor = 2
TempConfig.MenuBarFgColor = 0
TempConfig.MenuBarBgColor = 7
TempConfig.PopUpBgColor = 7
TempConfig.PopUpFgColor = 0
TempConfig.MainBgColor = 0
TempConfig.MainFgColor = 7
TempConfig.MainSelectedColor = 10
TempConfig.ShowHiddenFiles = FALSE
TempConfig.FileSortOrder = FILESORT + FILESORTNAMES
TempConfig.MenuDisabledFgColor = 8
TempConfig.ColorSchemeId = 0

Config = TempConfig


END SUB

SUB SetEditorPath (x AS INTEGER, y AS INTEGER)


DIM Body(6) AS STRING
Body(0) = "Set path for text editor used to edit "
Body(1) = "text files:"
Body(2) = ""
Body(3) = "Path:"
Body(4) = ""
Body(5) = "[Enter] Set new path"
Body(6) = "  [Esc] To cancel"

CALL DrawPopUp(x, y, "Set Text Editor Path", Body(), Config)


'draw input box area
COLOR 0, 0
LOCATE y + 4, x + 6
PRINT SPACE$(33)

COLOR Config.PopUpBgColor, Config.PopUpFgColor
LOCATE y + 4, x + 7
PRINT RTRIM$(Config.EditPath)



i$ = ""
isCleared% = FALSE

PathBuffer$ = ""

SaveChanges% = FALSE

WHILE i$ <> CHR$(27) AND i$ <> CHR$(13)

    i$ = UCASE$(INKEY$)

    IF NOT isCleared% AND i$ <> "" THEN
        COLOR 0, 0
        LOCATE y + 4, x + 7
        PRINT SPACE$(30)

        isCleared% = TRUE
    END IF

    IF i$ <> "" AND i$ <> CHR$(13) THEN

        'only allow 0-9, A-Z, :, ., and \ characters in path.
        IF (ASC(i$) >= ASC("0") AND ASC(i$) <= ASC("9")) OR (ASC(i$) >= ASC("A") AND ASC(i$) <= ASC("Z")) OR i$ = ":" OR i$ = "\" OR i$ = "." THEN
            PathBuffer$ = PathBuffer$ + i$
            

        'backspace, knock a char off the right side.
        ELSEIF LEN(PathBuffer$) > 0 AND ASC(i$) = 8 THEN
            LOCATE y + 4, x + 7 + LEN(PathBuffer$) - 1
            COLOR 0, 0
            PRINT " "
            PathBuffer$ = LEFT$(PathBuffer$, LEN(PathBuffer$) - 1)

        END IF


        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        LOCATE y + 4, x + 7
        PRINT PathBuffer$

    ELSEIF i$ = CHR$(13) THEN
        SaveChanges% = TRUE
    END IF

WEND

IF SaveChanges% AND LEN(PathBuffer$) > 0 THEN

    DIM SaveBody(2) AS STRING

    'make sure path is different than what is currently set.
    IF RTRIM$(PathBuffer$) <> RTRIM$(Config.EditPath) THEN

        IF FileExists(RTRIM$(PathBuffer$)) THEN

            Config.EditPath = RTRIM$(PathBuffer$)
            CALL SaveConfig(Config)

            SaveBody(0) = "Edit Path Set to: " + RTRIM$(Config.EditPath)
            SaveBody(1) = ""
        ELSE
            SaveBody(0) = "Cannot set path to editor. Path specified is invalid."
            SaveBody(1) = "Path: " + RTRIM$(PathBuffer$)

        END IF

    END IF

    
    SaveBody(2) = " Press any key to continue"

    CALL DrawPopUp(x, y, "Text Editor Path Set", SaveBody(), Config)

    SLEEP

END IF


END SUB

DEFSNG A-Z
SUB SetFileItems (Dir AS Directory)


'remove any extra space
FullPath$ = RTRIM$(Dir.FullPath)


'run shell command

FilesCmd$ = "DIR " + FullPath$

'DOSBox doesn't support attribute filter or sorting...
'so add sorting/filtering options if not dosbox.
IF NOT Config.DosBoxCompMode THEN
 
    FilesCmd$ = FilesCmd$ + " /A-D"

    IF NOT Config.ShowHiddenFiles THEN
        FilesCmd$ = FilesCmd$ + "-H"
    END IF

    FilesCmd$ = FilesCmd$ + " " + Config.FileSortOrder
END IF

FilesCmd$ = FilesCmd$ + " > " + TEMPFILEFILENAME


'TODO : hack is to not make errors scroll screen.
LOCATE 4, 23
COLOR 9, 0
SHELL FilesCmd$


'get dir info from temp dat file and parse as needed

DIM LineRead(MAXFILES) AS STRING
LinesRead% = 0
ValidLinesRead% = 0


'num extra lines returned at top of dir command
DirHeaderLines% = 5

'num extra lines returned at bottom of dir command
DirFooterLines% = 2

'if DOSBox, dir format is more condensed.
IF Config.DosBoxCompMode THEN
    DirHeaderLines% = 1
    DirFooterLines% = 2
END IF


OPEN TEMPFILEFILENAME FOR INPUT AS #1
WHILE NOT EOF(1)
   
    LINE INPUT #1, CurrentLine$
   
    'ignore directory lines (will appaar in dosbox compatibility mode results
    IF INSTR(CurrentLine$, "<DIR>") = 0 THEN
       
        IF LinesRead% >= DirHeaderLines% AND LinesRead% < UBOUND(LineRead) THEN
            LineRead(LinesRead% - DirHeaderLines%) = RTRIM$(CurrentLine$)
            ValidLinesRead% = ValidLinesRead% + 1
        END IF

        LinesRead% = LinesRead% + 1
    END IF
WEND

CLOSE #1



'build fileitems array

'last 3 lines are filler drive info. Ignore them.

FileItemLines% = ValidLinesRead% - DirFooterLines%
IF FileItemLines% < 0 THEN
    REDIM FileItems(0) AS FileItem
    EXIT SUB
ELSE

    REDIM FileItems(ValidLinesRead% - DirFooterLines%) AS FileItem


    FOR i% = 0 TO UBOUND(FileItems)

        FileName$ = RTRIM$(LEFT$(LineRead(i%), 8))
        FileExtension$ = MID$(LineRead(i%), 10, 3)

        ParentDir$ = RTRIM$(Dir.DirName)
        FileItems(i%).ParentDirName = ParentDir$

        'remove last slash on dir path because it will be added below.
        FullDirPath$ = RTRIM$(Dir.FullPath)
        IF RIGHT$(FullDirPath$, 1) = "\" THEN
            FullDirPath$ = LEFT$(FullDirPath$, LEN(FullDirPath$) - 1)
        END IF

        FileItems(i%).FullPath = RTRIM$(FullDirPath$) + "\" + FileName$ + "." + FileExtension$
        FileItems(i%).FileName = FileName$
        FileItems(i%).FileExtension = FileExtension$
   
        FileItems(i%).DisplayString = "  " + RTRIM$(LineRead(i%))
    NEXT i%
END IF


END SUB

DEFINT A-Z
SUB SetResolution (x AS INTEGER, y AS INTEGER)

'sets the display resolution of the application
'based on the user's input and saves it.

'currently not supported:
' 40 x 25, 40 x 43, 40 x 50

'supported:
' 80 x 25, 80 x 43, or 80 x 50

xOffset% = 3
yOffset% = 2
windowX% = x
windowY% = y

DIM Body(7) AS STRING
Body(0) = "Please select a resolution:"
Body(1) = " [ ] 80 x 25 Low Resolution"
Body(2) = " [ ] 80 x 43 High Resolution"
Body(3) = " [ ] 80 x 50 High Resolution"
Body(4) = ""
Body(5) = "Arrow keys to move between choices."
Body(6) = "Press [Space] to select, [Enter] to save changes"
Body(7) = "      [Esc] to cancel"

CALL DrawPopUp(windowX%, windowY%, "Set Screen Resolution", Body(), Config)

'convert num rows to easier identifier.
ResolutionIdx% = 0
SELECT CASE Config.NumRows

    CASE 43
        ResolutionIdx% = 1

    CASE 50
        ResolutionIdx% = 2

    CASE ELSE
        ResolutionIdx% = 0

END SELECT


'put a check next to current settings.
LOCATE windowY% + yOffset% + ResolutionIdx%, windowX% + xOffset%
COLOR Config.PopUpFgColor, Config.PopUpBgColor
PRINT CHR$(251)

'set start default selected option.
Selected% = 0
LOCATE windowY% + yOffset% + Selected%, windowX% + xOffset%
COLOR Config.PopUpBgColor, Config.PopUpFgColor

IF Selected% = ResolutionIdx% THEN
    PRINT CHR$(251)
ELSE
    PRINT " "
END IF



' get user input
i$ = ""
redraw% = FALSE
SaveSettings% = FALSE
WHILE i$ <> CHR$(13) AND i$ <> CHR$(27)

    i$ = UCASE$(INKEY$)

    'up
    IF i$ = CHR$(0) + CHR$(72) THEN
        IF Selected% > 0 THEN
            Selected% = Selected% - 1
            redraw% = TRUE
        END IF


    'down
    ELSEIF i$ = CHR$(0) + CHR$(80) THEN
        IF Selected% < 2 THEN
            Selected% = Selected% + 1
            redraw% = TRUE
        END IF

    'space - selected choice.
    ELSEIF i$ = " " THEN
        ResolutionIdx% = Selected%
        redraw% = TRUE


    'enter for save
    ELSEIF i$ = CHR$(13) THEN
        SaveSettings% = TRUE
    END IF

    'if moved, redraw selections.
    IF redraw% THEN
        redraw% = FALSE

        FOR i% = 0 TO 2

            LOCATE windowY% + yOffset% + i%, windowX% + xOffset%
            IF i% = Selected% THEN
                COLOR Config.PopUpBgColor, Config.PopUpFgColor
            ELSE
                COLOR Config.PopUpFgColor, Config.PopUpBgColor
            END IF
           
            IF i% = ResolutionIdx% THEN
                PRINT CHR$(251)
            ELSE
                PRINT " "
            END IF

        NEXT i%

    END IF


WEND

'save settings if needed and set new resolution.
IF SaveSettings% THEN

    NumRows% = 25
    SELECT CASE ResolutionIdx%

        CASE 0
            NumRows% = 25
        CASE 1
            NumRows% = 43
        CASE 2
            NumRows% = 50
    END SELECT

    IF Config.NumRows <> NumRows% THEN
        Config.NumRows = NumRows%
        CALL SaveConfig(Config)

        'TODO : will probably actually require a redraw to
        '       set the dir and file list view sizes.

        WIDTH Config.NumColumns, Config.NumRows
    END IF

END IF

END SUB

SUB SetRunOptions (x AS INTEGER, y AS INTEGER)

'Manages run options for file extensions based on
'users input and saves changes to the config file.

'LoadExtActions <- Should already be done.
'SaveExtActions <- to save list

xOffset% = 3
yOffset% = 4
windowX% = x
windowY% = y

' $DYNAMIC
DIM DisplayRows(UBOUND(ExtensionActions)) AS STRING
DIM Body(MaxRecords% + 7) AS STRING

i$ = ""
NumEntries% = UBOUND(ExtensionActions)

SaveSettings% = FALSE

FullRedraw% = TRUE


WHILE i$ <> CHR$(27)

    IF FullRedraw% THEN
        FullRedraw% = FALSE

        NumEntries% = UBOUND(ExtensionActions)
       
        MaxRecords% = Config.NumRows - y - 11
        MaxBoxSize% = Config.NumRows - y - 11

        IF UBOUND(ExtensionActions) < MaxRecords% THEN
            MaxRecords% = UBOUND(ExtensionActions)
        END IF

        LowRecord% = 0
        HighRecord% = MaxRecords%


        REDIM DisplayRows(UBOUND(ExtensionActions)) AS STRING
        'REDIM Body(MaxRecords% + 7) AS STRING
        REDIM Body(MaxBoxSize% + 7) AS STRING

        Body(0) = "  Below you can manage the run options for various file extensions." + SPACE$(8)
        Body(1) = ""
        Body(2) = "File ExtensionRun ActionĿ"

       
        'load up all display rows but only show the first max possible.
        FOR i% = 0 TO UBOUND(ExtensionActions)

            FileExtStr$ = SPACE$(4) + RTRIM$(ExtensionActions(i%).FileExtension)

            IF LEN(FileExtStr$) < 14 THEN
                FileExtStr$ = FileExtStr$ + SPACE$(14 - LEN(FileExtStr$))
            ELSEIF LEN(FileExtStr$) > 14 THEN
                FileExtStr$ = LEFT$(FileExtStr$, 14)
            END IF

            RunActStr$ = " " + RTRIM$(ExtensionActions(i%).RunAction)
            IF LEN(RunActStr$) < 60 THEN
                RunActStr$ = RunActStr$ + SPACE$(59 - LEN(RunActStr$))
            ELSEIF LEN(RunActStr$) > 59 THEN
                RunActStr$ = LEFT$(RunActStr$, 59)
            END IF


            DisplayRows(i%) = FileExtStr$ + "" + RunActStr$
        
            IF i% <= MaxRecords% THEN
                Body(i% + 3) = "" + DisplayRows(i%) + ""
            END IF
                
        NEXT i%

        'Fill screen with blanks if no actions exist for those slots yet
        FOR i% = UBOUND(ExtensionActions) + 1 TO MaxBoxSize%
            Body(i% + 3) = "" + SPACE$(14) + "" + SPACE$(59) + ""
        NEXT i%

        Body(MaxBoxSize% + 4) = ""
        Body(MaxBoxSize% + 5) = "Arrow keys to move between choices."
        Body(MaxBoxSize% + 6) = "Press [N] for New Entry, [DEL] to Delete an Entry"
        Body(MaxBoxSize% + 7) = "      [Esc] to Close Window"


        CALL DrawPopUp(windowX%, windowY%, "Set Run Options", Body(), Config)
       
        'set start default selected option.
        Selected% = 0

        LOCATE windowY% + yOffset% + Selected%, windowX% + xOffset% - 1
        COLOR Config.PopUpBgColor, Config.PopUpFgColor
        PRINT DisplayRows(Selected%)
        
    END IF

    i$ = UCASE$(INKEY$)

    'up
    IF i$ = CHR$(0) + CHR$(72) THEN
        IF Selected% > 0 THEN
            Selected% = Selected% - 1

            IF Selected% < LowRecord% THEN
                LowRecord% = LowRecord% - 1
                HighRecord% = HighRecord% - 1
            END IF

            redraw% = TRUE
        END IF


    'down
    ELSEIF i$ = CHR$(0) + CHR$(80) THEN
        IF Selected% < NumEntries% THEN
            Selected% = Selected% + 1

            IF Selected% > MaxRecords% THEN
                LowRecord% = LowRecord% + 1
                HighRecord% = HighRecord% + 1
            END IF

            redraw% = TRUE
        END IF

    'delete
    ELSEIF i$ = CHR$(0) + CHR$(&H53) THEN
        ExtToDelete$ = ExtensionActions(Selected%).FileExtension
        CALL DeleteExtAction(ExtToDelete$)
        FullRedraw% = TRUE


    'N - new entry
    ELSEIF i$ = "N" THEN
        CALL AddExtActions(6, 10)
                
        FullRedraw% = TRUE
        

    END IF

    'if moved, redraw selections.
    IF redraw% THEN
        redraw% = FALSE

        FOR i% = LowRecord% TO HighRecord%

            IF i% <= UBOUND(DisplayRows) THEN

                LOCATE windowY% + yOffset% + i% - LowRecord%, windowX% + xOffset% - 1
                IF i% = Selected% THEN
                    COLOR Config.PopUpBgColor, Config.PopUpFgColor
                ELSE
                    COLOR Config.PopUpFgColor, Config.PopUpBgColor
                END IF
          
                PRINT DisplayRows(i%)
            END IF

        NEXT i%

    END IF


WEND


END SUB

REM $STATIC
SUB SetSortOrder (x AS INTEGER, y AS INTEGER)

'sets the file sort order based on the user's selected and
'saves the settings if they have changed.


xOffset% = 3
yOffset% = 2
windowX% = x
windowY% = y


DIM Body(10) AS STRING
Body(0) = "Please select a sorting order:"
Body(1) = " [ ] Sort by Name"
Body(2) = " [ ] Sort by Size"
Body(3) = " [ ] Sort by Extension"
Body(4) = " [ ] Sort by Date"
Body(5) = ""
Body(6) = " [ ] Sort in reverse order"
Body(7) = ""
Body(8) = "Arrow key to move between choices."
Body(9) = "Press [Space] to select, [Enter] to save changes."
Body(10) = "      [Esc] to cancel"

CALL DrawPopUp(windowX%, windowY%, "Set Default Sorting Order", Body(), Config)

SortIdx% = 0
IsReverse% = FALSE

'check for reverse sort.
IF INSTR(Config.FileSortOrder, FILESORTREVERSE) > 0 THEN
    
    LOCATE windowY% + yOffset% + 5, windowX% + xOffset%
    COLOR Config.PopUpFgColor, Config.PopUpBgColor
    PRINT CHR$(251)

    IsReverse% = TRUE
END IF


'get sort index for sort orders.
IF INSTR(Config.FileSortOrder, FILESORTNAMES) > 0 THEN
    SortIdx% = 0
    
ELSEIF INSTR(Config.FileSortOrder, FILESORTSIZE) > 0 THEN
    SortIdx% = 1

ELSEIF INSTR(Config.FileSortOrder, FILESORTEXTENSION) > 0 THEN
    SortIdx% = 2
    
ELSEIF INSTR(Config.FileSortOrder, FILESORTDATE) > 0 THEN
    SortIdx% = 3
    
END IF


'put a check next to current sort setting.
LOCATE windowY% + yOffset% + SortIdx%, windowX% + xOffset%
COLOR Config.PopUpFgColor, Config.PopUpBgColor
PRINT CHR$(251)

'set start default selected option.
Selected% = 0
LOCATE windowY% + yOffset% + Selected%, windowX% + xOffset%
COLOR Config.PopUpBgColor, Config.PopUpFgColor

IF Selected% = SortIdx% THEN
    PRINT CHR$(251)
ELSE
    PRINT " "
END IF



' get user input
i$ = ""
redraw% = FALSE
SaveSettings% = FALSE
WHILE i$ <> CHR$(13) AND i$ <> CHR$(27)

    i$ = UCASE$(INKEY$)

    'up
    IF i$ = CHR$(0) + CHR$(72) THEN
        IF Selected% > 0 THEN
            Selected% = Selected% - 1
            redraw% = TRUE
        END IF


    'down
    ELSEIF i$ = CHR$(0) + CHR$(80) THEN
        IF Selected% < 4 THEN
            Selected% = Selected% + 1
            redraw% = TRUE
        END IF

    'space - selected choice.
    ELSEIF i$ = " " THEN

        'choice 4 is for reverse and separate from other options.
        IF Selected% = 4 THEN
            IF IsReverse THEN
                IsReverse% = FALSE
            ELSE
                IsReverse% = TRUE
            END IF

        ELSE
            SortIdx% = Selected%
        END IF

        redraw% = TRUE


    'enter for save
    ELSEIF i$ = CHR$(13) THEN
        SaveSettings% = TRUE
    END IF

    'if moved, redraw selections.
    IF redraw% THEN
        redraw% = FALSE

        FOR i% = 0 TO 4

            yExtraOffset% = 0
            IF i% = 4 THEN
                'Need an extra jump to get to the reverse check box.
                yExtraOffset% = 1
            
            END IF

            LOCATE windowY% + yOffset% + i% + yExtraOffset%, windowX% + xOffset%
            IF i% = Selected% THEN
                COLOR Config.PopUpBgColor, Config.PopUpFgColor
            ELSE
                COLOR Config.PopUpFgColor, Config.PopUpBgColor
            END IF
          
            'put a check mark next to selected sort and reverse if needed.
            IF i% = SortIdx% OR i% = 4 AND IsReverse% THEN
                PRINT CHR$(251)
            ELSE
                PRINT " "
            END IF

            
        NEXT i%

    END IF


WEND

'save settings if needed and set new sort order.
IF SaveSettings% THEN

    NewSortOrder$ = FILESORT
    IF IsReverse% THEN
        NewSortOrder$ = NewSortOrder$ + FILESORTREVERSE
    END IF
    
    SELECT CASE SortIdx%
        CASE 0
            NewSortOrder$ = NewSortOrder$ + FILESORTNAMES

        CASE 1
            NewSortOrder$ = NewSortOrder$ + FILESORTSIZE

        CASE 2
            NewSortOrder$ = NewSortOrder$ + FILESORTEXTENSION

        CASE 3
            NewSortOrder$ = NewSortOrder$ + FILESORTDATE

    END SELECT

    IF Config.FileSortOrder <> NewSortOrder$ THEN
        Config.FileSortOrder = NewSortOrder$
        CALL SaveConfig(Config)

        'force a redraw of the current directory with new order.
        CALL ChangeDirectory(CurrentPath)

    END IF

END IF


END SUB

DEFSNG A-Z
SUB SetSubDirs (BaseDir AS Directory)


'build shell command and create temp file based on BaseDir
BaseDirPath$ = RTRIM$(BaseDir.FullPath)


'check if basedirpath format "x:\" or "\" for root dir
IsRootDir% = FALSE
IF (LEN(BaseDirPath$) = 3 AND INSTR(BaseDirPath$, ":\") > 0) OR (LEN(BaseDirPath$) = 1 AND INSTR(BaseDirPath$, "\") > 0) THEN
    'LOCATE 19, 50
    'COLOR 12, 0
    'PRINT "I'm in a root dir!"
    IsRootDir% = TRUE
END IF

DirCommand$ = "dir " + BaseDirPath$ + " /AD /B /ON > " + TEMPDIRFILENAME

'DOSBox doesn't support attribute filter or sorting. :(
IF Config.DosBoxCompMode THEN
    DirCommand$ = "dir " + BaseDirPath$ + " /B > " + TEMPDIRFILENAME
END IF

IF DEBUG THEN
    PRINT "Building sub dirs for dir: "; BaseDir.FullPath
    PRINT DirCommand$
END IF

LOCATE 4, 23
COLOR 7, 0
SHELL DirCommand$


'temp memory holder of file contents
DIM LineRead(MAXSUBDIRS) AS STRING
LinesRead% = 0

'If not root, add back sub dir to first line
IF NOT IsRootDir% THEN
    LinesRead% = 1
    LineRead(0) = ".."
END IF


'read contents of temp file and place in memory.
OPEN TEMPDIRFILENAME FOR INPUT AS #1
WHILE NOT EOF(1)
    LINE INPUT #1, CurrentLine$

    'ignore any lines with file extensions.
    IF INSTR(CurrentLine$, ".") = 0 THEN
        LineRead(LinesRead%) = RTRIM$(CurrentLine$)
        LinesRead% = LinesRead% + 1
    END IF
WEND

CLOSE #1

'reset SubDirs to size of lines in file
ERASE SubDirs

'exit sub if no data was found
' not used.
'IF DirsReadFromFile% = 0 THEN
  
    'todo: check for files in directory. if files found
    '      add ".." sub dir. Not sure how to account for
    '      empty dir that don't exist yet...
   
'    REDIM SubDirs(0) AS Directory
'    LOCATE 23, 2
'    COLOR 4, 0
'    PRINT "INVALID DIRECTORY SELECTED."
'    END

'    EXIT SUB
'END IF

'only attempt to redim to size if any lines were read (dir found)


'resize sub dirs to new directory
IF LinesRead% > 0 THEN
    REDIM SubDirs(LinesRead% - 1) AS Directory
ELSE
    REDIM SubDirs(0) AS Directory
END IF


'Mask prev/next line
LOCATE 23, 2
COLOR 0, 0
PRINT "                            "


'append trailing slash if needed
IF RIGHT$(BaseDirPath$, 1) <> "\" THEN
    BaseDirPath$ = BaseDirPath$ + "\"
END IF


'populate sub dirs array
FOR i% = 0 TO UBOUND(SubDirs)
   
    IF DEBUG THEN
        COLOR 7, 0
        PRINT "Current Line = "; LineRead(i%)
    END IF

    SubDirs(i%).Id = i%
    SubDirs(i%).ParentId = BaseDir.ParentId
    SubDirs(i%).DirName = LineRead(i%)
    SubDirs(i%).FullPath = BaseDirPath$ + LineRead(i%)

NEXT i%


END SUB

DEFINT A-Z
SUB ToggleDosBoxMode (x AS INTEGER, y AS INTEGER)

'Flips dos box comp mode in the config and saves it.
'based on user input.

DosVer$ = GetDosVersion

NewSetting% = Config.DosBoxCompMode


'If comp mode is enabled, give proper warning based on DOS version running.
IF Config.DosBoxCompMode THEN


    IF INSTR(UCASE$(DosVer$), DOSBOXVERSUBSTR) THEN
        DIM Body(9) AS STRING
        Body(0) = "DOSBox Compatibilty mode currently enabled. Disabling"
        Body(1) = "compatibility mode while using DOSBox will cause"
        Body(2) = "directory and file functionality to break and may"
        Body(3) = "also cause adverse effects while interacting with the"
        Body(4) = "filesystem. Please be absolutely sure you want to"
        Body(5) = "disable this feature before continuing."
        Body(6) = ""
        Body(7) = "Detected DOS Version: " + DosVer$
        Body(8) = ""
        Body(9) = "Are you sure you want to disable this feature? [Y/N]"

        CALL DrawPopUp(x, y, "Disable DOSBox Compatibility Mode", Body(), Config)

    ELSE
        DIM Body(8) AS STRING
        Body(0) = "DOSBox Compatibilty mode currently enabled although"
        Body(1) = "the current version of DOS is not detected as running"
        Body(2) = "DOSBox. It is strongly advised to turn this mode off"
        Body(3) = "when not running in DOSBox as it may cause issues"
        Body(4) = "with functionality."
        Body(5) = ""
        Body(6) = "Detected DOS Version: " + DosVer$
        Body(7) = ""
        Body(8) = "Are you sure you want to disable this feature? [Y/N]"

        CALL DrawPopUp(x, y, "Disable DOSBox Compatibility Mode", Body(), Config)


    END IF

    i$ = ""
    WHILE i$ = ""

        i$ = INKEY$

        IF UCASE$(i$) = "Y" THEN
            NewSetting% = FALSE
        END IF
    WEND


'if DosBox mode is currently disabled:
ELSE
    IF INSTR(UCASE$(DosVer$), DOSBOXVERSUBSTR) THEN
        DIM Body(9) AS STRING
        Body(0) = "DOSBox Compatibilty mode currently disabled. Although"
        Body(1) = "the current version of DOS is currently detected as"
        Body(2) = "running DOSBox. It is strongly advised to enable this"
        Body(3) = "mode to ensure proper application functionality as well"
        Body(4) = "as avoiding any adverse effects while interacting with"
        Body(5) = "the filesystem."
        Body(6) = ""
        Body(7) = "Detected DOS Version: " + DosVer$
        Body(8) = ""
        Body(9) = "Are you sure you want to enable this feature? [Y/N]"

        CALL DrawPopUp(x, y, "Enable DOSBox Compatibility Mode", Body(), Config)

    ELSE
        DIM Body(9) AS STRING
        Body(0) = "DOSBox Compatibilty mode currently disabled and the"
        Body(1) = "the current version of DOS is not detected as running"
        Body(2) = "DOSBox. Enabling this mode is strongly discouraged"
        Body(3) = "when not running in DOSBox as adverse effects may"
        Body(4) = "happen while interacting with the filesystem as well"
        Body(5) = "as other potentially unknown errors."
        Body(6) = ""
        Body(7) = "Detected DOS Version: " + DosVer$
        Body(8) = ""
        Body(9) = "Are you sure you want to enable this feature? [Y/N]"

        CALL DrawPopUp(x, y, "Enable DOSBox Compatibility Mode", Body(), Config)


    END IF

    i$ = ""
    WHILE i$ = ""

        i$ = INKEY$

        IF UCASE$(i$) = "Y" THEN
            NewSetting% = TRUE
        END IF
    WEND


END IF



'if settings changed, save it.
IF NewSetting% <> Config.DosBoxCompMode THEN
    Config.DosBoxCompMode = NewSetting%
    Config.ShowDosBoxWarning = NewSetting%
    CALL SaveConfig(Config)

    'reset current directory back to base of hdd.
    'TODO : this should default to drive application
    '       is run from in case of running from disk
    '       with no C: drive.
    CALL ChangeDirectory("C:\")

END IF


END SUB

SUB ToggleHiddenFiles

' toggles between showing and hiding hidden files.
' do not bother if attempted in DOSBox mode.

IF NOT Config.DosBoxCompMode THEN

    IF Config.ShowHiddenFiles THEN
        Config.ShowHiddenFiles = FALSE
    
    ELSE
        Config.ShowHiddenFiles = TRUE

    END IF


    CALL SaveConfig(Config)

    'TODO : default dir should be base drive of where app was launched.
    CALL ChangeDirectory("C:\")
END IF

END SUB

